//  autodetect.cpp
//
//  field / interlace auto detection
//
//	Copyright (c) 2005 N099
//
#include <windows.h> 
#include <stdlib.h>
#include <string.h>
#include <xmmintrin.h>

#include "autodetect.h"
#include "hwdeintdefs.h"

//؎̂ărbg
#define  RS_BITS  2
#define  RS_BITS0 5

//field order detection
// -255*(2^(RS_BITS0-RS_BITS)) -- +255*(2^(RS_BITS0-RS_BITS)) ɐKꂽԂB
// +̓gbvt@[Xg -̓{gt@[Xg\
int
detect_order(const AD_IMGDATA *img, unsigned char *src, unsigned char *tmp)
{
	//[Ɖ[2pixelv4pixel͖
	//tB[h͏㉺畽ςĕ⊮vZ
	//1CƂɍv̉ʃrbgAI[o[t[
	int w = img->w * img->bpp;
	int sw = img->sw * img->bpp;
	int h = img->h - 2;
	int diff_top = 0;
	int diff_btm = 0;
	int i,j;
	unsigned char *src0, *tmp0;
	
	//4pixelȓ̏ꍇ肵Ȃ
	if(img->h <= 4){
		//[v̂߂ɃTvZ[u
		memcpy(tmp, src, img->sw * img->bpp * img->h);
		return 0;
	}

	//RGB555  RGB565 ͓ʈ
	if(img->format & ~(TYPE_RGB555 | TYPE_RGB565)){
		for(i=2; i<h; i+=2){
			int tmp_top = 0;
			int tmp_btm = 0;

			src0 = src + sw * i;
			tmp0 = tmp + sw * i;
			for(j=0; j<w; ++j){
				tmp_top += abs(*tmp0 - ((*(src0 - sw) + *(src0 + sw)) >> 1));
				tmp_btm += abs(*src0 - ((*(tmp0 - sw) + *(tmp0 + sw)) >> 1));
				tmp_top += abs(*(src0 + sw) - ((*tmp0 + *(tmp0 + sw * 2)) >> 1));
				tmp_btm += abs(*(tmp0 + sw) - ((*src0 + *(src0 + sw * 2)) >> 1));
				++src0;
				++tmp0;
			}
			diff_top += tmp_top >> RS_BITS;
			diff_btm += tmp_btm >> RS_BITS;
		}
	}else if(img->format & TYPE_RGB555){
		unsigned short shift_mask = 0x7BDE;
		unsigned short red_mask = 0x7C00;
		unsigned short green_mask = 0x3E0;
		unsigned short blue_mask = 0x1F;

		for(i=2; i<h; i+=2){
			int tmp_top = 0;
			int tmp_btm = 0;

			src0 = src + sw * i;
			tmp0 = tmp + sw * i;
			for(j=0; j<img->w; ++j){
				unsigned short pixel555a, pixel555b;
				int r0, g0, b0, r1, g1, b1;

				//top0
				pixel555a = *(unsigned short *)(src0 - sw);
				pixel555b = *(unsigned short *)(src0 + sw);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)tmp0;
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom0
				pixel555a = *(unsigned short *)(tmp0 - sw);
				pixel555b = *(unsigned short *)(tmp0 + sw);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)src0;
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//top1
				pixel555a = *(unsigned short *)tmp0;
				pixel555b = *(unsigned short *)(tmp0 + sw * 2);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)(src0 + sw);
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom1
				pixel555a = *(unsigned short *)src0;
				pixel555b = *(unsigned short *)(src0 + sw * 2);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)(tmp0 + sw);
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);

				src0 += 2;
				tmp0 += 2;
			}
			diff_top += tmp_top >> RS_BITS;
			diff_btm += tmp_btm >> RS_BITS;
		}
	}else if(img->format & TYPE_RGB565){
		unsigned short shift_mask = 0xF7DE;
		unsigned short red_mask = 0xF800;
		unsigned short green_mask = 0x7E0;
		unsigned short blue_mask = 0x1F;

		for(i=2; i<h; i+=2){
			int tmp_top = 0;
			int tmp_btm = 0;

			src0 = src + sw * i;
			tmp0 = tmp + sw * i;
			for(j=0; j<img->w; ++j){
				unsigned short pixel565a, pixel565b;
				int r0, g0, b0, r1, g1, b1;

				//top0
				pixel565a = *(unsigned short *)(src0 - sw);
				pixel565b = *(unsigned short *)(src0 + sw);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)tmp0;
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom0
				pixel565a = *(unsigned short *)(tmp0 - sw);
				pixel565b = *(unsigned short *)(tmp0 + sw);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)src0;
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//top1
				pixel565a = *(unsigned short *)tmp0;
				pixel565b = *(unsigned short *)(tmp0 + sw * 2);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)(src0 + sw);
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom1
				pixel565a = *(unsigned short *)src0;
				pixel565b = *(unsigned short *)(src0 + sw * 2);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)(tmp0 + sw);
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);

				src0 += 2;
				tmp0 += 2;
			}
			diff_top += tmp_top >> RS_BITS;
			diff_btm += tmp_btm >> RS_BITS;
		}
	}else{
		// ɂ͂Ȃ
	}

	//[v̂߂ɃTvZ[u
	memcpy(tmp, src, img->sw * img->bpp * img->h);
	return (diff_top - diff_btm)/((img->w * h * img->samples) >> RS_BITS0);
}

//ISSE𗘗p
int
detect_order_isse(const AD_IMGDATA *img, unsigned char *src, unsigned char *tmp)
{
	//[Ɖ[2pixelv4pixel͖
	//tB[h͏㉺畽ςĕ⊮vZ
	//1CƂɍv̉ʃrbgAI[o[t[
	int w = img->w * img->bpp;
	int sw = img->sw * img->bpp;
	int h = img->h - 2;
	int diff_top = 0;
	int diff_btm = 0;
	int i,j;
	unsigned char *src0, *tmp0;
	
	//4pixelȓ̏ꍇ肵Ȃ
	if(img->h <= 4){
		//[v̂߂ɃTvZ[u
		memcpy(tmp, src, img->sw * img->bpp * img->h);
		return 0;
	}

	//RGB555  RGB565 ͓ʈ
	if(img->format & ~(TYPE_RGB555 | TYPE_RGB565)){
		__m64 t0, t1, t2, s0, s1, s2;
		for(i=2; i<h; i+=2){
			int tmp_top = 0;
			int tmp_btm = 0;

			src0 = src + sw * i;
			tmp0 = tmp + sw * i;
			for(j=w ; j>7; j-=8){ //ISSE
				//top0
				t0 = *(__m64 *)tmp0;
				s2 = *(__m64 *)(src0 - sw);
				s1 = *(__m64 *)(src0 + sw);
				s2 = _mm_avg_pu8(s2, s1);
				s2 = _mm_sad_pu8(s2, t0);
				tmp_top += _mm_cvtsi64_si32(s2);
				//bottom0
				s0 = *(__m64 *)src0;
				t2 = *(__m64 *)(tmp0 - sw);
				t1 = *(__m64 *)(tmp0 + sw);
				t2 = _mm_avg_pu8(t2, t1);
				t2 = _mm_sad_pu8(t2, s0);
				tmp_btm += _mm_cvtsi64_si32(t2);
				//top1
				t2 = *(__m64 *)(tmp0 + sw * 2);
				t2 = _mm_avg_pu8(t2, t0);
				t2 = _mm_sad_pu8(t2, s1);
				tmp_top += _mm_cvtsi64_si32(t2);
				//bottom1
				s2 = *(__m64 *)(src0 + sw * 2);
				s2 = _mm_avg_pu8(s2, s0);
				s2 = _mm_sad_pu8(s2, t1);
				tmp_btm += _mm_cvtsi64_si32(s2);

				src0 += 8;
				tmp0 += 8;
			}
			for( ; j>0; --j){ //rest
				tmp_top += abs(*tmp0 - ((*(src0 - sw) + *(src0 + sw)) >> 1));
				tmp_btm += abs(*src0 - ((*(tmp0 - sw) + *(tmp0 + sw)) >> 1));
				tmp_top += abs(*(src0 + sw) - ((*tmp0 + *(tmp0 + sw * 2)) >> 1));
				tmp_btm += abs(*(tmp0 + sw) - ((*src0 + *(src0 + sw * 2)) >> 1));
				++src0;
				++tmp0;
			}
			diff_top += tmp_top >> RS_BITS;
			diff_btm += tmp_btm >> RS_BITS;
		}
	}else if(img->format & TYPE_RGB555){
		unsigned short shift_mask = 0x7BDE;
		unsigned short red_mask = 0x7C00;
		unsigned short green_mask = 0x3E0;
		unsigned short blue_mask = 0x1F;
		__m64 t0, t1, t2, s0, s1, s2;
		__m64 m_green_mask = _mm_set_pi16(0, green_mask, 0, green_mask);
		__m64 m_tmp0, m_tmp1;

		for(i=2; i<h; i+=2){
			int tmp_top = 0;
			int tmp_btm = 0;

			src0 = src + sw * i;
			tmp0 = tmp + sw * i;
			for(j=img->w; j>1; j-=2){
				//top0
				s2 = _mm_cvtsi32_si64(*(int *)(src0 - sw));
				s2 = _mm_shuffle_pi16(s2, 0xD8);
				m_tmp0 = _mm_and_si64(s2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(s2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s2 = _mm_srli_pi16(s2, 10);
				s2 = _mm_slli_pi16(s2, 3);
				s2 = _mm_or_si64(s2, m_tmp0);

				s1 = _mm_cvtsi32_si64(*(int *)(src0 + sw));
				s1 = _mm_shuffle_pi16(s1, 0xD8);
				m_tmp0 = _mm_and_si64(s1, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(s1, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s1 = _mm_srli_pi16(s1, 10);
				s1 = _mm_slli_pi16(s1, 3);
				s1 = _mm_or_si64(s1, m_tmp0);

				t0 = _mm_cvtsi32_si64(*(int *)tmp0);
				t0 = _mm_shuffle_pi16(t0, 0xD8);
				m_tmp0 = _mm_and_si64(t0, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(t0, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t0 = _mm_srli_pi16(t0, 10);
				t0 = _mm_slli_pi16(t0, 3);
				t0 = _mm_or_si64(t0, m_tmp0);

				s2 = _mm_avg_pu8(s2, s1);
				s2 = _mm_sad_pu8(s2, t0);
				tmp_top += _mm_cvtsi64_si32(s2);
				//bottom0
				t2 = _mm_cvtsi32_si64(*(int *)(tmp0 - sw));
				t2 = _mm_shuffle_pi16(t2, 0xD8);
				m_tmp0 = _mm_and_si64(t2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(t2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t2 = _mm_srli_pi16(t2, 10);
				t2 = _mm_slli_pi16(t2, 3);
				t2 = _mm_or_si64(t2, m_tmp0);

				t1 = _mm_cvtsi32_si64(*(int *)(tmp0 + sw));
				t1 = _mm_shuffle_pi16(t1, 0xD8);
				m_tmp0 = _mm_and_si64(t1, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(t1, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t1 = _mm_srli_pi16(t1, 10);
				t1 = _mm_slli_pi16(t1, 3);
				t1 = _mm_or_si64(t1, m_tmp0);

				t2 = _mm_avg_pu8(t2, t1);

				s0 = _mm_cvtsi32_si64(*(int *)src0);
				s0 = _mm_shuffle_pi16(s0, 0xD8);
				m_tmp0 = _mm_and_si64(s0, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(s0, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s0 = _mm_srli_pi16(s0, 10);
				s0 = _mm_slli_pi16(s0, 3);
				s0 = _mm_or_si64(s0, m_tmp0);

				t2 = _mm_sad_pu8(t2, s0);
				tmp_btm += _mm_cvtsi64_si32(t2);
				//top1
				t2 = _mm_cvtsi32_si64(*(int *)(tmp0 + sw * 2));
				t2 = _mm_shuffle_pi16(t2, 0xD8);
				m_tmp0 = _mm_and_si64(t2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(t2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t2 = _mm_srli_pi16(t2, 10);
				t2 = _mm_slli_pi16(t2, 3);
				t2 = _mm_or_si64(t2, m_tmp0);

				t2 = _mm_avg_pu8(t2, t0);
				t2 = _mm_sad_pu8(t2, s1);
				tmp_top += _mm_cvtsi64_si32(t2);
				//bottom1
				s2 = _mm_cvtsi32_si64(*(int *)(src0 + sw * 2));
				s2 = _mm_shuffle_pi16(s2, 0xD8);
				m_tmp0 = _mm_and_si64(s2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 6);
				m_tmp1 = _mm_slli_pi32(s2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s2 = _mm_srli_pi16(s2, 10);
				s2 = _mm_slli_pi16(s2, 3);
				s2 = _mm_or_si64(s2, m_tmp0);

				s2 = _mm_avg_pu8(s2, s0);
				s2 = _mm_sad_pu8(s2, t1);
				tmp_btm += _mm_cvtsi64_si32(s2);

				src0 += 4;
				tmp0 += 4;
			}
			for( ; j>0; ++j){
				unsigned short pixel555a, pixel555b;
				int r0, g0, b0, r1, g1, b1;

				//top0
				pixel555a = *(unsigned short *)(src0 - sw);
				pixel555b = *(unsigned short *)(src0 + sw);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)tmp0;
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom0
				pixel555a = *(unsigned short *)(tmp0 - sw);
				pixel555b = *(unsigned short *)(tmp0 + sw);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)src0;
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//top1
				pixel555a = *(unsigned short *)tmp0;
				pixel555b = *(unsigned short *)(tmp0 + sw * 2);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)(src0 + sw);
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom1
				pixel555a = *(unsigned short *)src0;
				pixel555b = *(unsigned short *)(src0 + sw * 2);
				pixel555b = (pixel555b & shift_mask) >> 1;
				pixel555b += (pixel555a & shift_mask) >> 1;
				pixel555a = *(unsigned short *)(tmp0 + sw);
				r0 = (pixel555a & red_mask) >> 7;
				r1 = (pixel555b & red_mask) >> 7;
				g0 = (pixel555a & green_mask) >> 2;
				g1 = (pixel555b & green_mask) >> 2;
				b0 = (pixel555a & blue_mask) << 3;
				b1 = (pixel555b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);

				src0 += 2;
				tmp0 += 2;
			}
			diff_top += tmp_top >> RS_BITS;
			diff_btm += tmp_btm >> RS_BITS;
		}
	}else if(img->format & TYPE_RGB565){
		unsigned short shift_mask = 0xF7DE;
		unsigned short red_mask = 0xF800;
		unsigned short green_mask = 0x7E0;
		unsigned short blue_mask = 0x1F;
		__m64 t0, t1, t2, s0, s1, s2;
		__m64 m_green_mask = _mm_set_pi16(0, green_mask, 0, green_mask);
		__m64 m_tmp0, m_tmp1;

		for(i=2; i<h; i+=2){
			int tmp_top = 0;
			int tmp_btm = 0;

			src0 = src + sw * i;
			tmp0 = tmp + sw * i;
			for(j=img->w; j>1; j-=2){
				//top0
				s2 = _mm_cvtsi32_si64(*(int *)(src0 - sw));
				s2 = _mm_shuffle_pi16(s2, 0xD8);
				m_tmp0 = _mm_and_si64(s2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(s2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s2 = _mm_srli_pi16(s2, 11);
				s2 = _mm_slli_pi16(s2, 3);
				s2 = _mm_or_si64(s2, m_tmp0);

				s1 = _mm_cvtsi32_si64(*(int *)(src0 + sw));
				s1 = _mm_shuffle_pi16(s1, 0xD8);
				m_tmp0 = _mm_and_si64(s1, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(s1, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s1 = _mm_srli_pi16(s1, 11);
				s1 = _mm_slli_pi16(s1, 3);
				s1 = _mm_or_si64(s1, m_tmp0);

				t0 = _mm_cvtsi32_si64(*(int *)tmp0);
				t0 = _mm_shuffle_pi16(t0, 0xD8);
				m_tmp0 = _mm_and_si64(t0, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(t0, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t0 = _mm_srli_pi16(t0, 11);
				t0 = _mm_slli_pi16(t0, 3);
				t0 = _mm_or_si64(t0, m_tmp0);

				s2 = _mm_avg_pu8(s2, s1);
				s2 = _mm_sad_pu8(s2, t0);
				tmp_top += _mm_cvtsi64_si32(s2);
				//bottom0
				t2 = _mm_cvtsi32_si64(*(int *)(tmp0 - sw));
				t2 = _mm_shuffle_pi16(t2, 0xD8);
				m_tmp0 = _mm_and_si64(t2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(t2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t2 = _mm_srli_pi16(t2, 11);
				t2 = _mm_slli_pi16(t2, 3);
				t2 = _mm_or_si64(t2, m_tmp0);

				t1 = _mm_cvtsi32_si64(*(int *)(tmp0 + sw));
				t1 = _mm_shuffle_pi16(t1, 0xD8);
				m_tmp0 = _mm_and_si64(t1, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(t1, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t1 = _mm_srli_pi16(t1, 11);
				t1 = _mm_slli_pi16(t1, 3);
				t1 = _mm_or_si64(t1, m_tmp0);

				t2 = _mm_avg_pu8(t2, t1);

				s0 = _mm_cvtsi32_si64(*(int *)src0);
				s0 = _mm_shuffle_pi16(s0, 0xD8);
				m_tmp0 = _mm_and_si64(s0, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(s0, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s0 = _mm_srli_pi16(s0, 11);
				s0 = _mm_slli_pi16(s0, 3);
				s0 = _mm_or_si64(s0, m_tmp0);

				t2 = _mm_sad_pu8(t2, s0);
				tmp_btm += _mm_cvtsi64_si32(t2);
				//top1
				t2 = _mm_cvtsi32_si64(*(int *)(tmp0 + sw * 2));
				t2 = _mm_shuffle_pi16(t2, 0xD8);
				m_tmp0 = _mm_and_si64(t2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(t2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				t2 = _mm_srli_pi16(t2, 11);
				t2 = _mm_slli_pi16(t2, 3);
				t2 = _mm_or_si64(t2, m_tmp0);

				t2 = _mm_avg_pu8(t2, t0);
				t2 = _mm_sad_pu8(t2, s1);
				tmp_top += _mm_cvtsi64_si32(t2);
				//bottom1
				s2 = _mm_cvtsi32_si64(*(int *)(src0 + sw * 2));
				s2 = _mm_shuffle_pi16(s2, 0xD8);
				m_tmp0 = _mm_and_si64(s2, m_green_mask);
				m_tmp0 = _mm_slli_pi16(m_tmp0, 5);
				m_tmp1 = _mm_slli_pi32(s2, 19);
				m_tmp0 = _mm_or_si64(m_tmp0, m_tmp1);
				s2 = _mm_srli_pi16(s2, 11);
				s2 = _mm_slli_pi16(s2, 3);
				s2 = _mm_or_si64(s2, m_tmp0);

				s2 = _mm_avg_pu8(s2, s0);
				s2 = _mm_sad_pu8(s2, t1);
				tmp_btm += _mm_cvtsi64_si32(s2);

				src0 += 4;
				tmp0 += 4;
			}
			for( ; j>0; ++j){
				unsigned short pixel565a, pixel565b;
				int r0, g0, b0, r1, g1, b1;

				//top0
				pixel565a = *(unsigned short *)(src0 - sw);
				pixel565b = *(unsigned short *)(src0 + sw);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)tmp0;
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom0
				pixel565a = *(unsigned short *)(tmp0 - sw);
				pixel565b = *(unsigned short *)(tmp0 + sw);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)src0;
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//top1
				pixel565a = *(unsigned short *)tmp0;
				pixel565b = *(unsigned short *)(tmp0 + sw * 2);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)(src0 + sw);
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_top += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);
				//bottom1
				pixel565a = *(unsigned short *)src0;
				pixel565b = *(unsigned short *)(src0 + sw * 2);
				pixel565b = (pixel565b & shift_mask) >> 1;
				pixel565b += (pixel565a & shift_mask) >> 1;
				pixel565a = *(unsigned short *)(tmp0 + sw);
				r0 = (pixel565a & red_mask) >> 8;
				r1 = (pixel565b & red_mask) >> 8;
				g0 = (pixel565a & green_mask) >> 3;
				g1 = (pixel565b & green_mask) >> 3;
				b0 = (pixel565a & blue_mask) << 3;
				b1 = (pixel565b & blue_mask) << 3;
				tmp_btm += abs(r0 - r1) + abs(g0 - g1) + abs(b0 - b1);

				src0 += 2;
				tmp0 += 2;
			}
			diff_top += tmp_top >> RS_BITS;
			diff_btm += tmp_btm >> RS_BITS;
		}
	}else{
		// ɂ͂Ȃ
	}
	
	//EMMS
	_mm_empty();

	//[v̂߂ɃTvZ[u
	memcpy(tmp, src, img->sw * img->bpp * img->h);
	return (diff_top - diff_btm)/((img->w * h * img->samples) >> RS_BITS0);
}

/*
//interlace detection
// 0 -- +255 ɐKꂽʂԂB
int detect_i(const AD_IMGDATA *img, unsigned char *src, unsigned char *tmp)
{}
int detect_i_isse(const AD_IMGDATA *img, unsigned char *src, unsigned char *tmp)
{}

//field order + interlace detection
// 16rbgɃI[_[A16rbgɃC^[XoʂpbN
int detect_both(const AD_IMGDATA *img, unsigned char *src, unsigned char *tmp)
{
}

int detect_both_isse(const AD_IMGDATA *img, unsigned char *src, unsigned char *tmp)
{
}
*/

//SSEg邩ǂ
//gƂ1AgȂƂ0Ԃ
int is_sse_usable()
{
	unsigned int sse = 0;

	//SSEo
	__asm{
			mov eax, 1
			cpuid
			mov sse, edx
	}
	if((sse & 0x02000000) == 0){
		return 0;
	}

	//OST|[gĂ邩
	_try {
		__asm xorps xmm0, xmm0
	}
	_except(EXCEPTION_EXECUTE_HANDLER) {
		if (_exception_code()==STATUS_ILLEGAL_INSTRUCTION)
		return 0;
	}

	return 1;
}

// oʕ\
void visualize_order(const AD_IMGDATA *img, unsigned char *dst, int res, int th, int h)
{
	int i = 512;
	int j,k;
	unsigned char *dst_res, *dst_ct, *dst_th0, *dst_th1;

	//tB[hI[_[̌ʕ\
	if(h*2+1 >= img->h) return;

	while(i > img->w){
		i >>= 1;
		res >>= 1;
		th >>=1;
	}
	if(abs(res)>(i>>1)) res = 0;
	if(abs(th)>(i>>1)) th = 0;

	dst += img->sw * img->bpp * h*2;

	for(k=0; k<2; k++){
		dst_ct  = dst + (i>>1) * img->bpp;
		dst_res = dst_ct + res * img->bpp;
		dst_th0 = dst_ct + th * img->bpp;
		dst_th1 = dst_ct - th * img->bpp;

		for(j=0; j<img->bpp; j++){
			*dst_res = ~*dst_res;
			*dst_ct  = dst_res == dst_ct ? *dst_ct : ~*dst_ct;
			if(!(h&1)){
				*dst_th0 = dst_res == dst_th0 ? *dst_th0 : ~*dst_th0;
				*dst_th1 = dst_res == dst_th1 ? *dst_th1 : ~*dst_th1;
			}
			++dst_res;
			++dst_ct;
			++dst_th0;
			++dst_th1;
		}
		dst += img->sw * img->bpp;
	}
}
//void visualize_i(const AD_IMGDATA *, unsigned char *, int);
//void visualize_both(const AD_IMGDATA *, unsigned char *, int);
