//  dsid.h
//
//	dsf identification class
//
//	Copyright (c) 2005 N099
//
#ifndef _DSID_H_
#define _DSID_H_

#include <strmif.h>
#include <objbase.h>

class dsfid
{
private:
	bool  has_CLSID;
	bool  has_NAME;
	CLSID cls;
	WCHAR ws_cls[CHARS_IN_GUID+1];
	WCHAR name[MAX_FILTER_NAME];
public:
	bool  listed;
	bool  checked;

	dsfid();
	dsfid(const dsfid &di);
	dsfid(CLSID &c);
	dsfid(WCHAR *s_cls, WCHAR *s_name);
	dsfid(CLSID &c, WCHAR *s_name);
	dsfid(WCHAR *s_name);
	~dsfid(){}

	const WCHAR *c_str_name() const;
	const WCHAR *c_str_cls() const;
	bool hasCLSID() const;
	bool hasNAME() const;
	void setNAME(WCHAR *s_name);
	void setCLSID(CLSID &c);
	void setCLSID(WCHAR *s_cls);
	CLSID getCLSID(void) const;

	bool operator==(dsfid &di);
	bool operator==(const dsfid &di);
	bool operator>(dsfid &di);
	bool operator<(dsfid &di);
	bool operator>=(dsfid &di);
	bool operator<=(dsfid &di);

	friend bool operator==(dsfid &di, CLSID &c);
	friend bool operator==(dsfid &di, WCHAR *s_name);
	friend bool operator==(CLSID &c, dsfid &di);
	friend bool operator==(WCHAR *s_name, dsfid &di);
};

#endif