//  hwdeint.cpp
//
//  hwdeint main
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>
#include <initguid.h>    // declares DEFINE_GUID to declare an EXTERN_C const.
#include <aviriff.h> 

#include <vector>
#include <algorithm>

#include "hwdeintuids.h"
#include "hwdeintdefs.h"
#include "hwdeint.h"
#include "hwdeintprop.h"
#include "prop_color.h"
#include "prop_dsf.h"
#include "prop_auto.h"
#include "util.h"
#include "autodetect.h"

using namespace std;

//
#define IsEnable(x,y) (((x)&(y)) == 0 ? 0 : 1)
#define chk_conf(x) ((m_conf.colorspace&(x)) || m_AD_getformat)

// util funcs prototype
static bool IsSame(AD_IMGDATA &, AD_IMGDATA &);
static bool IsSame(CFG_AR &, CFG_AR &);
static bool IsRectValid(VIDEOINFOHEADER *);
static bool IsRaw(DWORD);


//Factory Template
static WCHAR g_wszName[] = L"HW Deinterlace Filter";
CFactoryTemplate g_Templates[] = 
{
  { 
    g_wszName,
    &CLSID_HWDeint,
    CHWDeintFilter::CreateInstance,
    NULL,
    NULL
  },
  {
	L"HWDeint Configuration",
    &CLSID_HWDeintProp,
	CHWDeintProp::CreateInstance, 
	NULL,
	NULL
  },
  {
	L"Color format Configuration",
    &CLSID_HWDeintProp_Color,
	CHWDeintProp_Color::CreateInstance, 
	NULL,
	NULL
  },
  {
	L"DS Filter Configuration",
    &CLSID_HWDeintProp_DSF,
	CHWDeintProp_DSF::CreateInstance, 
	NULL,
	NULL
  },
  {
	L"Auto Detection Conf",
    &CLSID_HWDeintProp_AUTO,
	CHWDeintProp_AUTO::CreateInstance, 
	NULL,
	NULL
  }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);



extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);

BOOL APIENTRY DllMain( HANDLE hModule,
					   DWORD dwReason,
					   LPVOID lpReserved
					 )
{
	return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}

//ݒ̕\
void CALLBACK 
Configure(HWND hwnd, HINSTANCE hinst, LPSTR lpszCmdLine, int nCmdShow)
{
	HRESULT hr = CoInitialize(NULL);
	if(SUCCEEDED(hr)){
		IBaseFilter *pFilter;

		hr = CoCreateInstance(CLSID_HWDeint, 0, CLSCTX_INPROC_SERVER,
			IID_IBaseFilter, reinterpret_cast<void**>(&pFilter));
        if(SUCCEEDED(hr)){
			ISpecifyPropertyPages *pProp;
			hr = pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
			if (SUCCEEDED(hr)) 
			{
				IUnknown *pFilterUnk;
				pFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);

				CAUUID caGUID;
				pProp->GetPages(&caGUID);
				pProp->Release();
				OleCreatePropertyFrame(hwnd, 0, 0, g_wszName, 1,
					&pFilterUnk, caGUID.cElems, caGUID.pElems, 0, 0, NULL);

				pFilterUnk->Release();
				CoTaskMemFree(caGUID.pElems);
			}
            pFilter->Release();
		}
		CoUninitialize();
	}
}

// tB^o^
// fBA ^Cv錾B
REGPINTYPES sudInputTypes = { &MEDIATYPE_Video, &GUID_NULL };
REGPINTYPES sudOutputTypes = { &MEDIATYPE_Video, &GUID_NULL };


// s錾B
REGFILTERPINS sudPinReg[] = {
    // ̓sB
    { 0, FALSE, // Rendered?
         FALSE, // Output?
         FALSE, // Zero?
         FALSE, // Many?
         0, 0, 
         1, &sudInputTypes  // Media types.
    },
    // o̓sB
    { 0, FALSE, // _OĂ邩?
         TRUE, // o?
         FALSE, // [?
         FALSE, // ?
         0, 0, 
         1, &sudOutputTypes      // fBA ^CvB
    }
};
 
// tB^錾B
REGFILTER2 rf2FilterReg = {
    1,                // o[WԍB
    MERIT_DO_NOT_USE, // bgB
    2,                // s̐B
    sudPinReg         // sւ̃|C^B
};


STDAPI DllRegisterServer(void)
{
    HRESULT hr = AMovieDllRegisterServer2(TRUE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->RegisterFilter(
            CLSID_HWDeint,                // tB^ CLSIDB
            g_wszName,                       // tB^B
            NULL,                            // foCX jJB
            &CLSID_LegacyAmFilterCategory,   // DSF JeSB
            NULL,                       // CX^X f[^B
            &rf2FilterReg                    // tB^B
            );
        pFM2->Release();
    }
    return hr;
}

STDAPI DllUnregisterServer()
{
    HRESULT hr = AMovieDllRegisterServer2(FALSE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
            NULL, CLSID_HWDeint);
        pFM2->Release();
    }
    return hr;
}


/* create instance */

CUnknown * WINAPI CHWDeintFilter::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintFilter * pNewObject = new CHWDeintFilter(punk, phr);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}

/* query interfaces */

STDMETHODIMP CHWDeintFilter::NonDelegatingQueryInterface(REFIID riid, void **ppv)
{
	CheckPointer(ppv, E_POINTER);

	if (riid == IID_ISpecifyPropertyPages)
	{
        return GetInterface(static_cast<ISpecifyPropertyPages*>(this), ppv); 
	} 
	if (riid == IID_IHWDeint) {
        return GetInterface(static_cast<IHWDeint*>(this), ppv);
    }
	
	return CBaseFilter::NonDelegatingQueryInterface(riid, ppv);
}

/* get property page list */

STDMETHODIMP CHWDeintFilter::GetPages(CAUUID * pPages)
{
	if (pPages == NULL) return E_POINTER;
	pPages->cElems = 4;
	pPages->pElems = (GUID *)CoTaskMemAlloc(pPages->cElems * sizeof(GUID));
	if (pPages->pElems == NULL)
	{
		return E_OUTOFMEMORY;
	}
	pPages->pElems[0] = CLSID_HWDeintProp;
	pPages->pElems[1] = CLSID_HWDeintProp_Color;
	pPages->pElems[2] = CLSID_HWDeintProp_DSF;
	pPages->pElems[3] = CLSID_HWDeintProp_AUTO;

	return S_OK;
}

/* constructor */
CHWDeintFilter::CHWDeintFilter(LPUNKNOWN punk, HRESULT *phr)
 : CTransInPlaceFilter2(NAME("HW Deinterlace filter"), punk, CLSID_HWDeint, phr, true)
{
	// for Auto Loading
	m_conf.al.al_filter_name = AL_name;

	// LoadRegistry
	LoadRegistryInfo(&m_conf);
	LoadDSFlist(m_dsflist);

	//tray
	m_pTi = new TrayIcon(this);

	// aspect ratio
	if(m_conf.ar.ar_mode == AR_ORIG || m_conf.ar.ar_mode == AR_UD){
		m_ARflag = AR_STD;
	}else{
		m_ARflag = AR_CHG;
	}

	//auto detection
	m_AD_doAD = m_conf.ad.field ? true : false;
	if(m_AD_doAD) { reset_autodetect(); }
	m_AD_pTemp = NULL;
	m_AD_getformat = false;

	//detect SSE
	m_conf.ad.sse = m_conf.ad.sse & is_sse_usable();

	//for graphedt.exe + dscaler5
	m_i_num = 0;
	m_i_flg = 0;

	// for Auto Loading
	AL_loaded = false;

	//DbgSetModuleLevel(LOG_ERROR|LOG_MEMORY|LOG_TRACE,3);
	DbgSetModuleLevel(LOG_ERROR|LOG_TRACE,3);
	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintFilter::CHWDeintFilter")));
}

/* destructor */
CHWDeintFilter::~CHWDeintFilter()
{
	// for Auto Loading
	m_conf.al.al_filter_name = AL_name;

	SaveRegistryInfo(m_conf);
	if(m_pTi){
		delete m_pTi;
		m_pTi = NULL;
	}

	//p̈
	if(m_AD_pTemp != NULL){
		VirtualFree(m_AD_pTemp, 0, MEM_RELEASE);
	}

	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintFilter::~CHWDeintFilter")));
}



/* check input type */

HRESULT CHWDeintFilter::CheckInputType(const CMediaType *mtIn)
{
	BOOL all = FALSE;
	DWORD fcc = 0xffffffff;

	if(*mtIn->Type() != MEDIATYPE_Video){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
	
	if((m_conf.colorspace & TYPE_ALL) && !m_AD_getformat) {
		all = TRUE;
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB555 && chk_conf(TYPE_RGB555)) {
		fcc = BI_RGB;
		m_AD_img.format = TYPE_RGB555;
		m_AD_img.samples = 3;
		m_AD_img.bpp = 2; //16
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB565 && chk_conf(TYPE_RGB565)) {
		fcc = BI_RGB;
		m_AD_img.format = TYPE_RGB565;
		m_AD_img.samples = 3;
		m_AD_img.bpp = 2; //16
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB24 && chk_conf(TYPE_RGB24)) {
		fcc = BI_RGB;
		m_AD_img.format = TYPE_RGB24;
		m_AD_img.samples = 3;
		m_AD_img.bpp = 3; //24
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_RGB32 && chk_conf(TYPE_RGB32)) {
		fcc = BI_RGB;
		m_AD_img.format = TYPE_RGB32;
		m_AD_img.samples = 3;
		m_AD_img.bpp = 4; //32
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_ARGB32 && chk_conf(TYPE_ARGB32)) {
		fcc = BI_RGB;
		m_AD_img.format = TYPE_ARGB32;
		m_AD_img.samples = 3;
		m_AD_img.bpp = 4; //32
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YUY2 && chk_conf(TYPE_YUY2)) {
		fcc = FCC('YUY2');
		m_AD_img.format = TYPE_YUY2;
		m_AD_img.samples = 1;//2;
		m_AD_img.bpp = 2; //16
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_UYVY && chk_conf(TYPE_UYVY)) {
		fcc = FCC('UYVY');
		m_AD_img.format = TYPE_UYVY;
		m_AD_img.samples = 1;//2;
		m_AD_img.bpp = 2; //16
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YVYU && chk_conf(TYPE_YVYU)) {
		fcc = FCC('YVYU');
		m_AD_img.format = TYPE_YVYU;
		m_AD_img.samples = 1;//2;
		m_AD_img.bpp = 2; //16
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YUYV && chk_conf(TYPE_YUYV)) {
		fcc = FCC('YUYV');
		m_AD_img.format = TYPE_YUYV;
		m_AD_img.samples = 1;//2;
		m_AD_img.bpp = 2; //16
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_AYUV && chk_conf(TYPE_AYUV)) {
		fcc = FCC('AYUV');
		m_AD_img.format = TYPE_AYUV;
		m_AD_img.samples = 3;
		m_AD_img.bpp = 4; //32
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_Y211 && chk_conf(TYPE_Y211)) {
		fcc = FCC('Y211');
		m_AD_img.format = TYPE_Y211;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //8
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_Y41P && chk_conf(TYPE_Y41P)) {
		fcc = FCC('Y41P');
		m_AD_img.format = TYPE_Y41P;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_Y411 && chk_conf(TYPE_Y411)) {
		fcc = FCC('Y411');
		m_AD_img.format = TYPE_Y411;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YVU9 && chk_conf(TYPE_YVU9)) {
		fcc = FCC('YVU9');
		m_AD_img.format = TYPE_YVU9;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //9
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_I420 && chk_conf(TYPE_I420)) {
		fcc = FCC('I420');
		m_AD_img.format = TYPE_I420;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_YV12 && chk_conf(TYPE_YV12)) {
		fcc = FCC('YV12');
		m_AD_img.format = TYPE_YV12;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IYUV && chk_conf(TYPE_IYUV)) {
		fcc = FCC('IYUV');
		m_AD_img.format = TYPE_IYUV;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_NV12 && chk_conf(TYPE_NV12)) {
		fcc = FCC('NV12');
		m_AD_img.format = TYPE_NV12;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_NV21 && chk_conf(TYPE_NV21)) {
		fcc = FCC('NV21');
		m_AD_img.format = TYPE_NV21;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC1 && chk_conf(TYPE_IMC1)) {
		fcc = FCC('IMC1');
		m_AD_img.format = TYPE_IMC1;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC2 && chk_conf(TYPE_IMC2)) {
		fcc = FCC('IMC2');
		m_AD_img.format = TYPE_IMC2;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC3 && chk_conf(TYPE_IMC3)) {
		fcc = FCC('IMC3');
		m_AD_img.format = TYPE_IMC3;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else if (*mtIn->Subtype()==MEDIASUBTYPE_IMC4 && chk_conf(TYPE_IMC4)) {
		fcc = FCC('IMC4');
		m_AD_img.format = TYPE_IMC4;
		m_AD_img.samples = 1;
		m_AD_img.bpp = 1; //12
	} else {
		m_AD_getformat = false;
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
	m_AD_getformat = false;

	//check header + get bmiheader
	BITMAPINFOHEADER *pbmi = NULL;
	int width = 0;
	if (*mtIn->FormatType() == FORMAT_VideoInfo)
	{
		if(mtIn->cbFormat >= sizeof(VIDEOINFOHEADER)){
			pbmi = &reinterpret_cast<VIDEOINFOHEADER*>(mtIn->Format())->bmiHeader;
			width = reinterpret_cast<VIDEOINFOHEADER*>(mtIn->Format())->rcTarget.right;
		}
	} else if (*mtIn->FormatType() == FORMAT_VideoInfo2) {
		if(mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2)){
			VIDEOINFOHEADER2 *pvif2 = reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->Format());
			if(pvif2->dwInterlaceFlags && !m_pInput->IsConnected() && m_conf.misc.not_connect_iflg){
				m_i_flg = 1;
			    return VFW_E_TYPE_NOT_ACCEPTED;
			}
			pbmi = &(pvif2->bmiHeader);
			width = pvif2->rcTarget.right;
		}
	}

	// not connect if interlace flags exists
	if(m_i_flg && m_conf.misc.not_connect_iflg && !m_pInput->IsConnected())
	{
		m_i_num++;
		if(m_i_num<32 || m_conf.misc.not_connect_iflg == 1){ //32͓KȐ
			DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType iflg")));
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
	}

	if(pbmi){ //valid VideoInfo
		if(all){ //ALL
			if(IsRaw(pbmi->biCompression)){
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType RAW")));
				return S_OK; // RAW
			}
		}
		else{
			// set image size
			m_AD_img.h       =  abs(pbmi->biHeight);
			m_AD_img.sw      =  pbmi->biWidth;
			m_AD_img.w       =  width ? width : m_AD_img.sw;

			if(fcc==BI_RGB){ // RGB
				if(pbmi->biCompression == BI_RGB || pbmi->biCompression == BI_BITFIELDS){
					DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType RGB")));
					return S_OK;
				}
			}
			if(pbmi->biCompression == fcc){
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckInputType YUV")));
				return S_OK; //YUV
			}
		}
	}

	return VFW_E_TYPE_NOT_ACCEPTED;
}


/* get list of supported output colorspaces */

HRESULT CHWDeintFilter::GetMediaType(int iPosition, CMediaType *pMediaType)
{

	if (m_pInput->IsConnected() == FALSE)
	{
		return E_UNEXPECTED;
	}

    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }

	HRESULT hr = S_OK;
	BOOL fetched = FALSE;
	BOOL vif2 = FALSE;
	int num = -1;
	IEnumMediaTypes *pEnum;
	IPin            *pPin;
	AM_MEDIA_TYPE   *pMT;

	hr = m_pInput->ConnectedTo(&pPin);
	if(S_OK == hr){
		hr = pPin->EnumMediaTypes(&pEnum);
		if(S_OK == hr){
			while(iPosition>num){
				hr = pEnum->Next(1, &pMT, 0);
				if(S_OK == hr){
					CMediaType ctmp(*pMT);
					if(S_OK == CheckInputType(&ctmp)){
						if(ctmp.formattype == FORMAT_VideoInfo2){
							*pMediaType = *pMT;
							++num;
							vif2 = TRUE;
						}
						else if(ctmp.formattype == FORMAT_VideoInfo && !vif2){
							//VideoInfo2`ꍇVideoInfo͖
							*pMediaType = *pMT;
							++num;
						}
					}
					DeleteMediaType(pMT);
				}else{
					break;
				}
			}
			if(num == iPosition){
				if(pMediaType->formattype != FORMAT_VideoInfo 
					&& pMediaType->formattype != FORMAT_VideoInfo2)
				{ hr = E_UNEXPECTED; }

				if(pMediaType->formattype == FORMAT_VideoInfo){
					ConvertVideoInfoToVideoInfo2(pMediaType);
				}
				if (pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER2)){
					AddVIF2Flag(pMediaType);
				}else
				{ hr = E_UNEXPECTED; }
				fetched = TRUE;
			}
			pEnum->Release();
		}
		pPin->Release();
	}
	if(fetched) return hr;

    return VFW_S_NO_MORE_ITEMS;
}


HRESULT CHWDeintFilter::AddVIF2Flag(CMediaType *pMediaType)
{
	if(*pMediaType->FormatType() != FORMAT_VideoInfo2)
		return E_FAIL;

	VIDEOINFOHEADER2 *pVih = 
		reinterpret_cast<VIDEOINFOHEADER2*>(pMediaType->pbFormat);

	return AddVIF2Flag(pVih);
}

HRESULT CHWDeintFilter::AddVIF2Flag(AM_MEDIA_TYPE *pMediaType)
{
	if(pMediaType->formattype != FORMAT_VideoInfo2)
		return E_FAIL;

	VIDEOINFOHEADER2 *pVih = 
		reinterpret_cast<VIDEOINFOHEADER2*>(pMediaType->pbFormat);

	return AddVIF2Flag(pVih);
}


HRESULT CHWDeintFilter::AddVIF2Flag(VIDEOINFOHEADER2 *pVih)
{
	// pVih  VIDEOINFOHEADER o[ɃANZXB 
	//videoinfo2 flags
	if(m_conf.vif2.interlace){
		if(0 == m_conf.vif2.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeBobOrWeave;
		}else if(1 == m_conf.vif2.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeBobOnly;
		}else if(2 == m_conf.vif2.disp_mode){
			pVih->dwInterlaceFlags = AMINTERLACE_IsInterlaced | AMINTERLACE_DisplayModeWeaveOnly;
		}
		if(m_conf.vif2.vif_tff) pVih->dwInterlaceFlags |= AMINTERLACE_Field1First;

		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag vif2.interlace")));
	}
	//Aspect ratio
	if(m_conf.ar.ar_mode == AR_ORIG && m_pInput->IsConnected()){
		AM_MEDIA_TYPE *pamt = CreateMediaType(&m_pInput->CurrentMediaType());
		if(pamt->formattype == FORMAT_VideoInfo){
			VIDEOINFOHEADER *pV = reinterpret_cast<VIDEOINFOHEADER*>(pamt->pbFormat);
			BITMAPINFOHEADER *pbmi = &pV->bmiHeader;
			if(IsRectValid(pV)){
				pVih->dwPictAspectRatioX = pV->rcTarget.right;
				pVih->dwPictAspectRatioY = abs(pV->rcTarget.bottom);
			}else{
				pVih->dwPictAspectRatioX = pbmi->biWidth;
				pVih->dwPictAspectRatioY = abs(pbmi->biHeight);
			}
		}else if(pamt->formattype == FORMAT_VideoInfo2){
			VIDEOINFOHEADER2 *pV2 = reinterpret_cast<VIDEOINFOHEADER2*>(pamt->pbFormat);
			pVih->dwPictAspectRatioX = pV2->dwPictAspectRatioX;
			pVih->dwPictAspectRatioY = pV2->dwPictAspectRatioY;
		}

		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_ORIG")));
		DeleteMediaType(pamt);
	}else if(m_conf.ar.ar_mode == AR_43){
		pVih->dwPictAspectRatioX = 4;
		pVih->dwPictAspectRatioY = 3;
		pVih->dwControlFlags = m_ARflag==AR_AMC ? AMCONTROL_PAD_TO_4x3 : 0;
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_43 %d"), (m_ARflag==AR_AMC)?1:0));
	}else if(m_conf.ar.ar_mode == AR_169){
		pVih->dwPictAspectRatioX = 16;
		pVih->dwPictAspectRatioY = 9;
		pVih->dwControlFlags = m_ARflag==AR_AMC ? AMCONTROL_PAD_TO_16x9 : 0;
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_169 %d"), (m_ARflag==AR_AMC)?1:0));
	}else if(m_conf.ar.ar_mode == AR_UD){
		pVih->dwPictAspectRatioX = m_conf.ar.ar_h;
		pVih->dwPictAspectRatioY = m_conf.ar.ar_v;
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::AddVIF2Flag AR_UD")));
	}
	
	return S_OK;
}

// Search HWDeint in filter graph
HRESULT CHWDeintFilter::SearchHWDeint(PIN_DIRECTION dir, IPin *pPin)
{
	// returns S_OK if HWDeint does not exist
	HRESULT hr;

	//search upstream only
	if(PINDIR_OUTPUT == dir){
		return S_OK;
	}
    ASSERT(dir == PINDIR_INPUT);

	PIN_INFO ReceivePinInfo;
	CLSID    cls; 

	hr = pPin->QueryPinInfo(&ReceivePinInfo);
	if (FAILED(hr)) {
		return E_FAIL;
	}
	hr = ReceivePinInfo.pFilter->GetClassID(&cls);
	if (FAILED(hr)) {
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}

	// check filter CLSID
	if(IsEqualCLSID(cls, CLSID_HWDeint)) {
		//same CLSID
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::SearchHWDeint hwdeint found.")));
		return S_FALSE;
	}
	//different CLSID
	IEnumPins  *pEnum;
	IPin       *pPin2;
	BOOL       bFound = FALSE;
	hr = ReceivePinInfo.pFilter->EnumPins(&pEnum);
	if (FAILED(hr))
	{
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}
	while(pEnum->Next(1, &pPin2, 0) == S_OK && !bFound)
	{
		PIN_DIRECTION PinDirThis;
		pPin2->QueryDirection(&PinDirThis);
		if (dir == PinDirThis){
			IPin *pPin3;
			if(S_OK == pPin2->ConnectedTo(&pPin3)){
				//recursive search
				hr = SearchHWDeint(dir, pPin3);
				if(S_OK != hr) bFound = TRUE;//found or an error occurred
				pPin3->Release();
			}
		}
		pPin2->Release();
	}
	pEnum->Release();

	//clean up
	QueryPinInfoReleaseFilter(ReceivePinInfo);

	return hr;
}

// Check filter list in filter graph (search recursively)
HRESULT CHWDeintFilter::CheckFilter(PIN_DIRECTION dir, IPin *pPin)
{
	// returns S_OK if filter does not exist
	HRESULT hr;
	/*
	if(PINDIR_OUTPUT == dir){
		return S_OK;
	}
    ASSERT(dir == PINDIR_INPUT);
	*/

	PIN_INFO    ReceivePinInfo;
	FILTER_INFO ReceiveFilterInfo;
	CLSID cls;
	dsfid di;

	hr = pPin->QueryPinInfo(&ReceivePinInfo);
	if (FAILED(hr)) {
		return E_FAIL;
	}
	hr = ReceivePinInfo.pFilter->GetClassID(&cls);
	if (SUCCEEDED(hr)) {
		di.setCLSID(cls);
	}
	hr = ReceivePinInfo.pFilter->QueryFilterInfo(&ReceiveFilterInfo);
	if (FAILED(hr)) {
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}

	di.setNAME(ReceiveFilterInfo.achName);
	// check filter name
	if(m_dsflist.end() != find(m_dsflist.begin(), m_dsflist.end(), di)) {
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckFilter filter found.")));
		return E_FAIL;
	}
	//different name
	IEnumPins  *pEnum;
	IPin       *pPin2;
	BOOL       bFound = FALSE;
	hr = ReceivePinInfo.pFilter->EnumPins(&pEnum);
	if (FAILED(hr))
	{
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}
	while(pEnum->Next(1, &pPin2, 0) == S_OK && !bFound)
	{
		PIN_DIRECTION PinDirThis;
		pPin2->QueryDirection(&PinDirThis);
		if (dir == PinDirThis){
			IPin *pPin3;
			if(S_OK == pPin2->ConnectedTo(&pPin3)){
				//recursive search
				hr = CheckFilter(dir, pPin3);
				if(S_OK != hr) bFound = TRUE;//found or an error occurred
				pPin3->Release();
			}
		}
		pPin2->Release();
	}
	pEnum->Release();

	//clean up
	QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
	QueryPinInfoReleaseFilter(ReceivePinInfo);

	return hr;
}

// Check filter list (only direct connected filter)
HRESULT CHWDeintFilter::CheckFilter(IPin *pPin)
{

	// do not connect listed filters
	PIN_INFO ReceivePinInfo;
	FILTER_INFO ReceiveFilterInfo;
	CLSID cls;
	dsfid di;

	if (FAILED(pPin->QueryPinInfo(&ReceivePinInfo))) {
		return E_FAIL;
	}
	if (SUCCEEDED(ReceivePinInfo.pFilter->GetClassID(&cls))) {
		di.setCLSID(cls);
	}
	if (FAILED(ReceivePinInfo.pFilter->QueryFilterInfo(&ReceiveFilterInfo))) {
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		return E_FAIL;
	}
	di.setNAME(ReceiveFilterInfo.achName);

	// check filter name
	if(m_dsflist.end() != find(m_dsflist.begin(), m_dsflist.end(), di)) {
		QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
		QueryPinInfoReleaseFilter(ReceivePinInfo);
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CheckFilter filter found.")));
		return E_FAIL;
	}
	QueryFilterInfoReleaseGraph(ReceiveFilterInfo);
	QueryPinInfoReleaseFilter(ReceivePinInfo);

	return S_OK;
}

// dir is the direction of our pin.
// pReceivePin is the pin we are connecting to.
HRESULT CHWDeintFilter::CompleteConnect(PIN_DIRECTION dir,IPin *pReceivePin)
{
    UNREFERENCED_PARAMETER(pReceivePin);
    ASSERT(m_pInput);
    ASSERT(m_pOutput);

    // if we are not part of a graph, then don't indirect the pointer
    // this probably prevents use of the filter without a filtergraph
    if (!m_pGraph) {
        return VFW_E_NOT_IN_GRAPH;
    }

	// Check Connecting filter
	//if(S_OK != CheckFilter(pReceivePin)) {
	//	return E_FAIL;
	//}
	if(S_OK != CheckFilter(dir, pReceivePin)) {
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CompleteConnect !filter")));
		return E_FAIL;
	}

	// reconnect
    if (dir == PINDIR_OUTPUT) {
		if( m_pInput->IsConnected() ) {
			HRESULT hr;

			//set conversion
			m_convert = m_conf.misc.conv_upstream ? true : false;
			//foce different allocaters
			static_cast<CTransInPlaceInputPin2*>
				(m_pInput)->FoceDifferentAlloc(m_conf.misc.copy_always);

			//free memory for auto detection
			m_AD_doAD = m_conf.ad.field ? true : false;
			if(m_AD_pTemp != NULL){
				VirtualFree(m_AD_pTemp, 0, MEM_RELEASE);
				m_AD_pTemp = NULL;
			}

			hr = ReconnectPin( m_pInput, &m_pInput->CurrentMediaType() );
			if(SUCCEEDED(hr) && m_AD_doAD){
				//get memory size
				m_AD_getformat = true;
				CheckInputType(&m_pOutput->CurrentMediaType());
				// mۂ郁ʂ́AXgChύXl
				// 2̗ݏɂĂ
				int d = 0;
				int s = m_AD_img.sw;
				while(s>0){
					d |= s;
					s /= 2;
				}
				m_AD_pTemp_size = m_AD_img.bpp * m_AD_img.h * (d + 1);

				//alocate memory for auto detection
				m_AD_pTemp = (BYTE *)VirtualAlloc(NULL, m_AD_pTemp_size, MEM_COMMIT, PAGE_READWRITE);
				if(NULL == m_AD_pTemp){
					hr = E_OUTOFMEMORY;
					m_AD_doAD = false;
				}
			}

			return hr;
        }
        return E_FAIL;
    } // if (dir == PINDIR_OUTPUT)
	
    ASSERT(dir == PINDIR_INPUT);

	if(S_OK != SearchHWDeint( dir, pReceivePin )) {
		DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CompleteConnect !hwdeint")));
		return E_FAIL;
	}

	//Auto loading
	if(m_conf.al.al_clsid != GUID_NULL && !AL_loaded){
		IBaseFilter *pFilter = NULL;
		HRESULT hr = CoCreateInstance(m_conf.al.al_clsid, 0, 
			CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)&pFilter);

		AL_loaded = true;
		if (SUCCEEDED(hr)){
			hr = m_pGraph->AddFilter(pFilter, m_conf.al.al_filter_name);
		    if (SUCCEEDED(hr)){
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::CompleteConnect AutoLoading")));
			}
			pFilter->Release();
		}
	}

	//ok
    return S_OK;

} // ComnpleteConnect


// override this to customize the transform process
HRESULT CHWDeintFilter::Receive(IMediaSample *pSample)
{
    /*  Check for other streams and pass them on */
    AM_SAMPLE2_PROPERTIES * const pProps = m_pInput->SampleProps();
    if (pProps->dwStreamId != AM_STREAM_MEDIA) {
        return m_pOutput->Deliver(pSample);
    }
    HRESULT hr;
	IMediaSample *pSrc = pSample;

    // Start timing the TransInPlace (if PERF is defined)
    MSR_START(m_idTransInPlace);

    if (UsingDifferentAllocators()) {

        // We have to copy the data.
        pSample = Copy(pSample);

        if (pSample==NULL) {
            MSR_STOP(m_idTransInPlace);
            return E_UNEXPECTED;
        }
		// convert mediatype (ŃRs[Ăꍇ)
		if(m_convert){
			CMediaType *pMT = NULL;
			hr = pSample->GetMediaType((AM_MEDIA_TYPE**)&pMT);
			if (hr == S_OK)
			{
				if(*pMT->FormatType() == FORMAT_VideoInfo){
					ConvertVideoInfoToVideoInfo2(pMT);
					AddVIF2Flag(pMT);
					pSample->SetMediaType(pMT);
					DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Receive UD type change")));
				}
				DeleteMediaType(pMT);
			}
		}
    }

    // transform the data
    hr = Transform(pSample, pSrc);

    // Stop the clock and log it (if PERF is defined)
    MSR_STOP(m_idTransInPlace);

    if (FAILED(hr)) {
        DbgLog((LOG_TRACE, 1, TEXT("Error from TransInPlace")));
        if (UsingDifferentAllocators()) {
            pSample->Release();
        }
        return hr;
    }

    // the Transform() function can return S_FALSE to indicate that the
    // sample should not be delivered; we only deliver the sample if it's
    // really S_OK (same as NOERROR, of course.)
    if (hr == NOERROR) {
        hr = m_pOutput->Deliver(pSample);
    } else {
        //  But it would be an error to return this private workaround
        //  to the caller ...
        if (S_FALSE == hr) {
            // S_FALSE returned from Transform is a PRIVATE agreement
            // We should return NOERROR from Receive() in this cause because
            // returning S_FALSE from Receive() means that this is the end
            // of the stream and no more data should be sent.
            m_bSampleSkipped = TRUE;
            if (!m_bQualityChanged) {
                NotifyEvent(EC_QUALITY_CHANGE,0,0);
                m_bQualityChanged = TRUE;
            }
            hr = NOERROR;
        }
    }

    // release the output buffer. If the connected pin still needs it,
    // it will have addrefed it itself.
    if (UsingDifferentAllocators()) {
        pSample->Release();
    }

    return hr;

} // Receive

// transform
HRESULT CHWDeintFilter::Transform(IMediaSample *pDest, IMediaSample *pSrc)
{
	HRESULT hr;

	//set Aspect ratio
	if(m_ARflag == AR_CHG){
		CMediaType *pMT = NULL;
		hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
		if (hr == S_OK) //fBA^Cv̕ύXꍇ
		{
			if(*pMT->FormatType() == FORMAT_VideoInfo){
				ConvertVideoInfoToVideoInfo2(pMT);
				AddVIF2Flag(pMT);
			}

			VIDEOINFOHEADER2 *pvif2 = reinterpret_cast<VIDEOINFOHEADER2*>(pMT->pbFormat);
			m_ARflag = AR_AMC;

			pvif2->dwControlFlags |= AMCONTROL_USED;
			if(S_OK != m_pOutput->GetConnected()->QueryAccept(pMT)){
				pvif2->dwControlFlags = 0;
				m_ARflag = AR_STD;
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AMC denied w/c")));
			}

			AddVIF2Flag(pMT);
			pDest->SetMediaType(pMT);

			DeleteMediaType(pMT);

			DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AR type change")));
		}else{
			CMediaType mt(m_pOutput->CurrentMediaType());
			VIDEOINFOHEADER2 *pvif2 = reinterpret_cast<VIDEOINFOHEADER2*>(mt.pbFormat);
	
			m_ARflag = AR_AMC;
			pvif2->dwControlFlags |= AMCONTROL_USED;
			if(S_OK != m_pOutput->GetConnected()->QueryAccept(&mt)){
				pvif2->dwControlFlags = 0;
				m_ARflag = AR_STD;
				DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AMC denied")));
			}
			AddVIF2Flag(&mt);
			pDest->SetMediaType(&mt);
			//m_pOutput->SetMediaType(pMT);

			DbgLog((LOG_TRACE, 3, TEXT("CHWDeintFilter::Transform AR set")));
		}
	}


	//set AM_SAMPLE2_PROPERTIES
	if(m_conf.vif2.interlace && m_conf.am2.use_imedia2){
		IMediaSample2 *pms2 = NULL;
		AM_SAMPLE2_PROPERTIES prop2;

		hr = pDest->QueryInterface(IID_IMediaSample2, (void **)&pms2);
		if(S_OK == hr){
			hr = pms2->GetProperties(FIELD_OFFSET(AM_SAMPLE2_PROPERTIES, pbBuffer), (PBYTE)&prop2);
			if(S_OK == hr){
				//Auto detection
				if(m_AD_doAD && m_conf.ad.field && (m_AD_step>0 || m_conf.ad.duration==0)){
					DoAutoDetect(pDest, pSrc);
				}

				// add flags
				prop2.dwTypeSpecificFlags = AM_VIDEO_FLAG_INTERLEAVED_FRAME; //default
				if(m_conf.am2.am2_tff){
					prop2.dwTypeSpecificFlags |= AM_VIDEO_FLAG_FIELD1FIRST;
				}
				if(m_conf.am2.weave){
					prop2.dwTypeSpecificFlags |= AM_VIDEO_FLAG_WEAVE;
				}

				// convert mediatype i㗬VideoInfoŐڑĂꍇj
				if(m_convert && prop2.pMediaType){
					CMediaType mt(*prop2.pMediaType);
					if(prop2.pMediaType->formattype == FORMAT_VideoInfo){
						ConvertVideoInfoToVideoInfo2(prop2.pMediaType);
						AddVIF2Flag(prop2.pMediaType);
					}
					//m_pOutput->SetMediaType(&mt);
				}
				pms2->SetProperties(FIELD_OFFSET(AM_SAMPLE2_PROPERTIES, pbBuffer), (PBYTE)&prop2);
			}
			pms2->Release();
		}else{
			DbgLog((LOG_ERROR, 3, TEXT("CHWDeintFilter::Transform get IM2IF faild")));
		}
	}


	return S_OK;
}

//
HRESULT CHWDeintFilter::DoAutoDetect(IMediaSample *pDest, IMediaSample *pSrc)
{
	BYTE *src, *dst;
	HRESULT hr = pSrc->GetPointer(&src);
	if(SUCCEEDED(hr)){
		hr = pDest->GetPointer(&dst);
	} else {
		return hr;
	}
	if(SUCCEEDED(hr)){
		AD_IMGDATA img_old = m_AD_img;
		CMediaType cmt;
		//摜tH[}bg𓾂
		m_AD_getformat = true;
		hr = m_pOutput->GetConnected()->ConnectionMediaType(&cmt);
		CheckInputType(&cmt);

		if(SUCCEEDED(hr) && !IsSame(img_old, m_AD_img)){
			//摜tH[}bgςƂ
			reset_autodetect();
			if((int)m_AD_pTemp_size < m_AD_img.bpp * m_AD_img.h * m_AD_img.sw){
				//TCYȂꍇĊm
				if(m_AD_pTemp != NULL){
					VirtualFree(m_AD_pTemp, 0, MEM_RELEASE);
					m_AD_pTemp = NULL;
				}
				m_AD_pTemp_size = m_AD_img.bpp * m_AD_img.h * m_AD_img.sw;
				m_AD_pTemp = (BYTE *)VirtualAlloc
					(NULL, m_AD_pTemp_size, MEM_COMMIT, PAGE_READWRITE);
				if(NULL == m_AD_pTemp){
					hr = E_OUTOFMEMORY;
				}
			}
		}
		if(SUCCEEDED(hr) && NULL!=m_AD_pTemp){
			int tff, sum, asum;
			//o
			if(m_conf.ad.sse){
				tff = detect_order_isse(&m_AD_img, src, m_AD_pTemp);
			}else{
				tff = detect_order(&m_AD_img, src, m_AD_pTemp);
			}
			if(0 != m_AD_results.size()){
				m_AD_results.push_front(tff);
				if((int)m_AD_results.size() > m_conf.ad.e_term + 1){
					//ЂƂ_~[f[^
					m_AD_results.pop_back();
				}

				sum = 0;
				asum = 0;
				for(UINT i=0; i<m_AD_results.size()-1; ++i){
					if(m_conf.ad.vis){
						//ʂ̉
						visualize_order(&m_AD_img, dst,
							m_AD_results[i], m_conf.ad.core ,i);
					}
					tff = abs(m_AD_results[i]) > m_conf.ad.core ? m_AD_results[i] : 0;
					if(tff){
						//sumɂ 1(tff) or -1(bff) Z
						sum += tff>0 ? 1 : -1;
						//asumɂ͏1(C^o)Z
						asum += 1;
					}
				}
				sum = m_conf.ad.field_flip ? -sum : sum;
				if(sum){
					//tB[hoʊi[
					CAutoLock lock(&m_csShared);
					m_conf.am2.am2_tff = sum > 0 ? 1 : 0;
				}
				if(m_conf.ad.interlace){
					//C^oʂ̊i[
					CAutoLock lock(&m_csShared);
					sum = 0==m_conf.ad.i_percent ? asum : (100*asum)/m_conf.ad.e_term;
					m_conf.am2.weave = sum > m_conf.ad.i_percent ? 0 : 1;
				}
			}else{
				//ڂ̌ʂ͎̂Ă
				m_AD_results.push_front(0);
			}
		}
	}
	m_AD_step = m_conf.ad.duration ? m_AD_step - 1 : 0;

	return hr;
}

//Xg[~Ƃ̏
HRESULT CHWDeintFilter::StopStreaming()
{
	HRESULT hr = CTransInPlaceFilter2::StopStreaming();
	if(SUCCEEDED(hr)){
		if(NULL != m_AD_pTemp){
			ZeroMemory(m_AD_pTemp, m_AD_pTemp_size);
		}
		reset_autodetect();
	}

	return hr;
}

//IHWDeint interfaces
STDMETHODIMP CHWDeintFilter::get_cfg(CONFIG *cfg)
{
	CAutoLock lock(&m_csShared);
	*cfg = m_conf;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg(CONFIG cfg)
{
	CAutoLock lock(&m_csShared);
	m_ARflag = IsSame(cfg.ar, m_conf.ar) ? AR_STD : AR_CHG;
	m_conf = cfg;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_am2(CFG_AM2 *cfg_am2)
{
	CAutoLock lock(&m_csShared);
	*cfg_am2 = m_conf.am2;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_am2(CFG_AM2 cfg_am2)
{
	CAutoLock lock(&m_csShared);
	m_conf.am2 = cfg_am2;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_vif2(CFG_VIF2 *cfg_vif2)
{
	CAutoLock lock(&m_csShared);
	*cfg_vif2 = m_conf.vif2;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_ar(CFG_AR *cfg_ar)
{
	CAutoLock lock(&m_csShared);
	*cfg_ar = m_conf.ar;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_ar(CFG_AR cfg_ar)
{
	CAutoLock lock(&m_csShared);
	m_ARflag = IsSame(cfg_ar, m_conf.ar) ? AR_STD : AR_CHG;
	m_conf.ar = cfg_ar;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_auto(CFG_AUTO *cfg_auto)
{
	CAutoLock lock(&m_csShared);
	*cfg_auto = m_conf.ad;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_auto(CFG_AUTO cfg_auto)
{
	CAutoLock lock(&m_csShared);
	m_conf.ad = cfg_auto;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_color(int *color)
{
	CAutoLock lock(&m_csShared);
	*color = m_conf.colorspace;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_color(int color)
{
	CAutoLock lock(&m_csShared);
	m_conf.colorspace = color;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_cfg_al(CFG_AL *cfg_al)
{
	CAutoLock lock(&m_csShared);
	cfg_al->al_clsid = m_conf.al.al_clsid;
	cfg_al->al_filter_name = NULL;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_cfg_al(CFG_AL cfg_al)
{
	CAutoLock lock(&m_csShared);
	m_conf.al.al_clsid = cfg_al.al_clsid;
	if(NULL != cfg_al.al_filter_name){
		wcsncpy_s(AL_name, MAX_FILTER_NAME, cfg_al.al_filter_name, _TRUNCATE);
	}else{
		ZeroMemory(AL_name, sizeof(AL_name));
	}
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::get_dsflist(vector<dsfid> *list)
{
	CAutoLock lock(&m_csShared);
	*list = m_dsflist;
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::set_dsflist(const vector<dsfid> *list)
{
	CAutoLock lock(&m_csShared);
	m_dsflist = *list;
	return S_OK;
}

// tray
STDMETHODIMP CHWDeintFilter::is_tray_visible(void) const {
	return m_conf.misc.tray;
}

STDMETHODIMP CHWDeintFilter::hide_tray(void){
	if(m_pTi){
		CAutoLock lock(&m_csShared);
		m_pTi->hide();
	}
	return S_OK;
}

STDMETHODIMP CHWDeintFilter::show_tray(void){
	if(m_pTi){
		CAutoLock lock(&m_csShared);
		m_pTi->show();
	}
	return S_OK;
}

//reset auto detection
STDMETHODIMP CHWDeintFilter::reset_autodetect(void){
	CAutoLock lock(&m_csShared);
	m_AD_step = m_conf.ad.duration;
	m_AD_results.clear();
	return S_OK;
}

//set field order + interlace detect threshold
STDMETHODIMP CHWDeintFilter::set_core_th(int th){
	if(th <= AD_MAX_CORE_TH && th >= AD_MIN_CORE_TH){
		CAutoLock lock(&m_csShared);
		m_conf.ad.core = th;
	}
	return S_OK;
}

//set interlace detect threshold
STDMETHODIMP CHWDeintFilter::set_ipercent_th(int th){
	if(th <= AD_MAX_PERCENT_TH && th >= AD_MIN_PERCENT_TH){
		CAutoLock lock(&m_csShared);
		m_conf.ad.i_percent = th;
	}
	return S_OK;
}

//Util funcs
static bool IsSame(AD_IMGDATA &a, AD_IMGDATA &b)
{
	if(a.bpp==b.bpp && a.format==b.format && a.h==b.h
		&& a.samples==b.samples && a.sw==b.sw && a.w==b.w)
	{
		return true;
	}

	return false;
}

static bool IsSame(CFG_AR &a, CFG_AR &b)
{
	if(a.ar_h==b.ar_h && a.ar_mode==b.ar_mode && a.ar_v==b.ar_v)
	{
		return true;
	}
	return false;
}

static bool IsRectValid(VIDEOINFOHEADER *pV)
{
	if(    pV->rcSource.bottom == pV->rcTarget.bottom
		&& pV->rcSource.left   == pV->rcTarget.left
		&& pV->rcSource.right  == pV->rcTarget.right
		&& pV->rcSource.top    == pV->rcTarget.top    )
	{
		if(pV->rcSource.right > 0 && pV->rcSource.bottom != 0)
			return true;
	}
	return false;
}

//FOURCC
static bool IsRaw(DWORD fcc)
{
	switch (fcc)
	{
	case BI_RGB:
	case BI_BITFIELDS:
	case FCC('YUY2'):
	case FCC('UYVY'):
	case FCC('YVYU'):
	case FCC('YUYV'):
	case FCC('AYUV'):
	case FCC('Y211'):
	case FCC('Y41P'):
	case FCC('Y411'):
	case FCC('YVU9'):
	case FCC('I420'):
	case FCC('YV12'):
	case FCC('IYUV'):
	case FCC('NV12'):
	case FCC('NV21'):
	case FCC('IMC1'):
	case FCC('IMC2'):
	case FCC('IMC3'):
	case FCC('IMC4'):
		return true;
	default:
		break;
	}

	return false;
}

