//  hwdeintprop.cpp
//
//	hwdeint main property page
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>

#include "hwdeintuids.h"
#include "hwdeint.h"

#include "hwdeintprop.h"
#include "resource.h"

#define IsEqual(x,y) ((x) == (y) ? 1 : 0) 

// -----------------------------------------

CUnknown * WINAPI CHWDeintProp::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintProp * pNewObject = new CHWDeintProp(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}


CHWDeintProp::CHWDeintProp(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("HWDeintProp"), pUnk, IDD_HWDeintProp, IDS_HWDeintProp)
	,m_pHWDeint(0)
{
	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintProp::CHWDeintProp")));
}

void CHWDeintProp::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}


HRESULT CHWDeintProp::OnConnect(IUnknown *pUnk)
{
	ASSERT(m_pHWDeint == NULL);
	HRESULT hr;
	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintProp::OnConnect")));

	// pUnk ŃtB^̃JX^ C^[tFCX₢킹B
	hr = pUnk->QueryInterface(IID_IHWDeint, reinterpret_cast<void**>(&m_pHWDeint));

	if(FAILED(hr)){
		return hr;
	}
	
	// ݒǂݍ
	return m_pHWDeint->get_cfg(&m_config);
}

HRESULT CHWDeintProp::OnActivate(void)
{
    ASSERT(m_pHWDeint != NULL);
	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintProp::OnActivate")));

	// Load Buttons
	//VIF2
	SendDlgItemMessage(m_Dlg, IDC_INTERLACE, BM_SETCHECK, m_config.vif2.interlace, 0);
	SendDlgItemMessage(m_Dlg, IDC_VIFF1F, BM_SETCHECK, m_config.vif2.vif_tff, 0);
	SendDlgItemMessage(m_Dlg, IDC_BOBONLY, BM_SETCHECK, m_config.vif2.disp_mode&1, 0);
	SendDlgItemMessage(m_Dlg, IDC_WAVEONLY, BM_SETCHECK, (m_config.vif2.disp_mode&2)<<1, 0);
	SendDlgItemMessage(m_Dlg, IDC_BOBORWEAVE, BM_SETCHECK, !m_config.vif2.disp_mode, 0);
	//AMSP2
	SendDlgItemMessage(m_Dlg, IDC_AM2F1F, BM_SETCHECK, m_config.am2.am2_tff, 0);
	SendDlgItemMessage(m_Dlg, IDC_IMEDIA2, BM_SETCHECK, m_config.am2.use_imedia2, 0);
	SendDlgItemMessage(m_Dlg, IDC_WEAVE, BM_SETCHECK, m_config.am2.weave, 0);
	//MISC
	SendDlgItemMessage(m_Dlg, IDC_IFLAGGED, BM_SETCHECK, m_config.misc.not_connect_iflg, 0);
	SendDlgItemMessage(m_Dlg, IDC_TRANS_UPS, BM_SETCHECK, m_config.misc.conv_upstream, 0);
	SendDlgItemMessage(m_Dlg, IDC_TRAY, BM_SETCHECK, m_config.misc.tray, 0);
	SendDlgItemMessage(m_Dlg, IDC_COPY_ALWAYS, BM_SETCHECK, m_config.misc.copy_always, 0);
	//Aspect Ratio
	SendDlgItemMessage(m_Dlg, IDC_AR_ORIG, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_ORIG), 0);
	SendDlgItemMessage(m_Dlg, IDC_AR_4, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_43), 0);
	SendDlgItemMessage(m_Dlg, IDC_AR_16, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_169), 0);
	SendDlgItemMessage(m_Dlg, IDC_AR_UD, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_UD), 0);
	SetDlgItemInt(m_Dlg, IDC_AR_H, m_config.ar.ar_h, TRUE);
	SetDlgItemInt(m_Dlg, IDC_AR_V, m_config.ar.ar_v, TRUE);

	EnableWindow(GetDlgItem(m_Dlg, IDC_VIFF1F), m_config.vif2.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_BOBONLY), m_config.vif2.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_WAVEONLY), m_config.vif2.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_BOBORWEAVE), m_config.vif2.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_IMEDIA2), m_config.vif2.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_WEAVE), m_config.am2.use_imedia2&&m_config.vif2.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_AM2F1F), m_config.am2.use_imedia2&&m_config.vif2.interlace);

    return S_OK;
}

BOOL CHWDeintProp::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_RESET){
			//l̏
			int color = m_config.colorspace; //J[Xy[X͕ۑ
			CFG_AUTO ad = m_config.ad; //ۑ
			CFG_AL al = m_config.al; //[hۑ
			ZeroMemory(&m_config, sizeof(CONFIG));
			m_config.colorspace = color;
			m_config.ad = ad;
			m_config.al = al;
			m_config.misc.tray = 1;
			m_config.misc.conv_upstream = 1;
			m_config.misc.not_connect_iflg = 1;
			m_config.ar.ar_h = AR_H_DEF;
			m_config.ar.ar_v = AR_V_DEF;

			//VIF2
			SendDlgItemMessage(m_Dlg, IDC_INTERLACE, BM_SETCHECK, m_config.vif2.interlace, 0);
			SendDlgItemMessage(m_Dlg, IDC_VIFF1F, BM_SETCHECK, m_config.vif2.vif_tff, 0);
			SendDlgItemMessage(m_Dlg, IDC_BOBONLY, BM_SETCHECK, m_config.vif2.disp_mode&1, 0);
			SendDlgItemMessage(m_Dlg, IDC_WAVEONLY, BM_SETCHECK, (m_config.vif2.disp_mode&2)<<1, 0);
			SendDlgItemMessage(m_Dlg, IDC_BOBORWEAVE, BM_SETCHECK, !m_config.vif2.disp_mode, 0);
			//AMSP2
			SendDlgItemMessage(m_Dlg, IDC_AM2F1F, BM_SETCHECK, m_config.am2.am2_tff, 0);
			SendDlgItemMessage(m_Dlg, IDC_IMEDIA2, BM_SETCHECK, m_config.am2.use_imedia2, 0);
			SendDlgItemMessage(m_Dlg, IDC_WEAVE, BM_SETCHECK, m_config.am2.weave, 0);
			//MISC
			SendDlgItemMessage(m_Dlg, IDC_IFLAGGED, BM_SETCHECK, m_config.misc.not_connect_iflg, 0);
			SendDlgItemMessage(m_Dlg, IDC_TRANS_UPS, BM_SETCHECK, m_config.misc.conv_upstream, 0);
			SendDlgItemMessage(m_Dlg, IDC_TRAY, BM_SETCHECK, m_config.misc.tray, 0);
			SendDlgItemMessage(m_Dlg, IDC_COPY_ALWAYS, BM_SETCHECK, m_config.misc.copy_always, 0);
			//Aspect Ratio
			SendDlgItemMessage(m_Dlg, IDC_AR_ORIG, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_ORIG), 0);
			SendDlgItemMessage(m_Dlg, IDC_AR_4, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_43), 0);
			SendDlgItemMessage(m_Dlg, IDC_AR_16, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_169), 0);
			SendDlgItemMessage(m_Dlg, IDC_AR_UD, BM_SETCHECK, IsEqual(m_config.ar.ar_mode,AR_UD), 0);
			SetDlgItemInt(m_Dlg, IDC_AR_H, m_config.ar.ar_h, TRUE);
			SetDlgItemInt(m_Dlg, IDC_AR_V, m_config.ar.ar_v, TRUE);

			EnableWindow(GetDlgItem(m_Dlg, IDC_VIFF1F), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_BOBONLY), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_WAVEONLY), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_BOBORWEAVE), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_IMEDIA2), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_WEAVE), m_config.am2.use_imedia2&&m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_AM2F1F), m_config.am2.use_imedia2&&m_config.vif2.interlace);

			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_INTERLACE){
			m_config.vif2.interlace = !m_config.vif2.interlace;
			EnableWindow(GetDlgItem(m_Dlg, IDC_VIFF1F), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_BOBONLY), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_WAVEONLY), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_BOBORWEAVE), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_IMEDIA2), m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_WEAVE), m_config.am2.use_imedia2&&m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_AM2F1F), m_config.am2.use_imedia2&&m_config.vif2.interlace);

			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_VIFF1F){
			m_config.vif2.vif_tff = !m_config.vif2.vif_tff;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_IMEDIA2){
			m_config.am2.use_imedia2 = !m_config.am2.use_imedia2;
			EnableWindow(GetDlgItem(m_Dlg, IDC_WEAVE), m_config.am2.use_imedia2&&m_config.vif2.interlace);
			EnableWindow(GetDlgItem(m_Dlg, IDC_AM2F1F), m_config.am2.use_imedia2&&m_config.vif2.interlace);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_WEAVE){
			m_config.am2.weave = !m_config.am2.weave;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AM2F1F){
			m_config.am2.am2_tff = !m_config.am2.am2_tff;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_BOBONLY){
			m_config.vif2.disp_mode = 1;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_WAVEONLY){
			m_config.vif2.disp_mode = 2;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_BOBORWEAVE){
			m_config.vif2.disp_mode = 0;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_TRAY){
			m_config.misc.tray = !m_config.misc.tray;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_COPY_ALWAYS){
			m_config.misc.copy_always = !m_config.misc.copy_always;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_IFLAGGED){
			m_config.misc.not_connect_iflg = 
				(int)SendDlgItemMessage(m_Dlg, IDC_IFLAGGED, BM_GETCHECK, 0,0);
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_TRANS_UPS){
			m_config.misc.conv_upstream = !m_config.misc.conv_upstream;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AR_ORIG){
			m_config.ar.ar_mode = AR_ORIG;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AR_4){
			m_config.ar.ar_mode = AR_43;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AR_16){
			m_config.ar.ar_mode = AR_169;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AR_UD){
			m_config.ar.ar_mode = AR_UD;
			SetDirty();
			return (LRESULT) 1;
		}
		else if (LOWORD(wParam) == IDC_AR_H){
			switch (HIWORD(wParam))
			{
			case EN_CHANGE:
				BOOL translated;
				int  val;
				val = GetDlgItemInt(m_Dlg, IDC_AR_H, &translated, FALSE);
				if(translated && val>=0 && m_config.ar.ar_h != val){
					SetDirty();
					return (LRESULT) 1;
				}
				break;
			default:
				break;
			}
		}
		else if (LOWORD(wParam) == IDC_AR_V){
			switch (HIWORD(wParam))
			{
			case EN_CHANGE:
				BOOL translated;
				int  val;
				val = GetDlgItemInt(m_Dlg, IDC_AR_V, &translated, FALSE);
				if(translated && val>=0 && m_config.ar.ar_v != val){
					SetDirty();
					return (LRESULT) 1;
				}
			default:
				break;
			}
		}

		break;

	}
	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT CHWDeintProp::OnApplyChanges(void)
{
	BOOL translated;
	int  val;
	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintProp::OnApplyChanges")));

	//AXǂݍ
	val = GetDlgItemInt(m_Dlg, IDC_AR_H, &translated, FALSE);
	if(translated && val>0) m_config.ar.ar_h = val;
	val = GetDlgItemInt(m_Dlg, IDC_AR_V, &translated, FALSE);
	if(translated && val>0) m_config.ar.ar_v = val;
	SetDlgItemInt(m_Dlg, IDC_AR_H, m_config.ar.ar_h, FALSE);
	SetDlgItemInt(m_Dlg, IDC_AR_V, m_config.ar.ar_v, FALSE);

	m_pHWDeint->set_cfg(m_config);

	//gC̐ݒ
	if(m_config.misc.tray){
		m_pHWDeint->show_tray();
	}else{
		m_pHWDeint->hide_tray();
	}

	return S_OK;
} 

HRESULT CHWDeintProp::OnDisconnect(void)
{
	DbgLog((LOG_TRACE, 2, TEXT("CHWDeintProp::OnDisconnect")));

    if (m_pHWDeint)
    {
        m_pHWDeint->Release();
        m_pHWDeint = NULL;
    }
    return S_OK;
}


