//  prop_dsf.cpp
//
//	hwdeint dsf property
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>
#include <commctrl.h>

#include <vector>
#include <algorithm>

#include <tchar.h>
#include <strsafe.h>

#include "util.h"
#include "hwdeintuids.h"
#include "hwdeint.h"

#include "prop_dsf.h"
#include "resource.h"
using namespace std;

static TCHAR col_name0[] = _T("FriendlyName");
static TCHAR col_name1[] = _T("CLSID");
static WCHAR str_noitem[] = _T("???");

CUnknown * WINAPI CHWDeintProp_DSF::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintProp_DSF * pNewObject = new CHWDeintProp_DSF(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}

CHWDeintProp_DSF::CHWDeintProp_DSF(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("HWDeintProp_DSF"), pUnk, IDD_HWDeintProp_DSF, IDS_HWDeintProp_DSF)
	,m_pHWDeint(0), m_sort(1), m_sort2(1)
{
	/*
	INITCOMMONCONTROLSEX icex;

	icex.dwSize = sizeof(icex);
	icex.dwICC = ICC_LISTVIEW_CLASSES;

	InitCommonControlsEx(&icex);
	*/
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::CHWDeintProp_DSF")));
}

void CHWDeintProp_DSF::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}

HRESULT CHWDeintProp_DSF::OnConnect(IUnknown *pUnk)
{
	ASSERT(m_pHWDeint == NULL);
	HRESULT hr;
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnConnect")));
	// pUnk ŃtB^̃JX^ C^[tFCX₢킹B
	hr = pUnk->QueryInterface(IID_IHWDeint, reinterpret_cast<void**>(&m_pHWDeint));
	if(FAILED(hr)){
		return hr;
	}
	
	// ݒǂݍ
	m_newmerit = m_merit = GetMerit();
	m_pHWDeint->get_dsflist(&m_dsflist);
	m_pHWDeint->get_cfg_al(&m_cfg_al);

	//ׂẴtB^ǂݍ
	EnumFilters();

	return hr;
}

HRESULT CHWDeintProp_DSF::OnActivate(void)
{
    ASSERT(m_pHWDeint != NULL);
	clicked = false;

	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnActivate")));

	LVCOLUMN lvc0, lvc1;
	ZeroMemory(&lvc0, sizeof(LVCOLUMN));
	ZeroMemory(&lvc1, sizeof(LVCOLUMN));

	//tB^Xg̕\
	SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_SETEXTENDEDLISTVIEWSTYLE, 
		0, LVS_EX_CHECKBOXES | LVS_EX_GRIDLINES );
	lvc0.mask =LVCF_TEXT | LVCF_WIDTH;
	lvc0.pszText = (LPTSTR)col_name0;
	lvc0.cchTextMax = ARRAYSIZE(col_name0);
	lvc0.iSubItem = 0;
	lvc0.cx = 250;
	lvc1.mask =LVCF_TEXT | LVCF_WIDTH;
	lvc1.pszText = (LPTSTR)col_name1;
	lvc1.cchTextMax = ARRAYSIZE(col_name1);
	lvc1.iSubItem = 1;
	lvc1.cx = 275;
	SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_INSERTCOLUMN, 0, (LPARAM)&lvc0);
	SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_INSERTCOLUMN, 1, (LPARAM)&lvc1);
	ListFilters();

	//bgݒ
	TCHAR s[16];
	StringCchPrintf(s, ARRAYSIZE(s), _T("%.8x"), m_newmerit);
	
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_LIMITTEXT, 8, 0);
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_ADDSTRING, 0, (LPARAM)TEXT("MERIT_PREFERRED+2"));
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_ADDSTRING, 0, (LPARAM)TEXT("MERIT_DO_NOT_USE(default)"));
	SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, WM_SETTEXT, 0, (LPARAM)s);

	//Auto loading̐ݒ
	//clsid疼O
	dsfid di(m_cfg_al.al_clsid);
	vector<dsfid>::iterator p = find(m_dsflist_all.begin(), m_dsflist_all.end(), di);
	if(m_dsflist_all.end() != p){ //
		SendDlgItemMessageW(m_Dlg, IDC_AUTOLOAD_NAME, WM_SETTEXT, 0, (LPARAM)p->c_str_name());
		StringCchCopyW(m_al_name, MAX_FILTER_NAME, p->c_str_name());
	}else{
		m_cfg_al.al_clsid = GUID_NULL;
		SendDlgItemMessage(m_Dlg, IDC_AUTOLOAD_NAME, WM_SETTEXT, 0, (LPARAM)_T("N/A"));
	}

    return S_OK;
}



BOOL CHWDeintProp_DSF::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		if (LOWORD(wParam) == IDC_DSF_CLEAR){
			ClearFilterList();
			SetDirty();
			return (LRESULT) 1;
		} else if (LOWORD(wParam) == IDC_DSF_MERIT){
			if(1 == OnClickMerit(wParam)) return (LRESULT) 1;
		} else if (LOWORD(wParam) == IDC_AUTOLOAD_SEL){
			if(1 == OnClickALSel()) SetDirty();
			return (LRESULT) 1;
		} else if (LOWORD(wParam) == IDC_AUTOLOAD_CLS){
			if(m_cfg_al.al_clsid != GUID_NULL){
				m_cfg_al.al_clsid = GUID_NULL;
				SendDlgItemMessage(m_Dlg, IDC_AUTOLOAD_NAME, WM_SETTEXT, 0, (LPARAM)_T("N/A"));
				SetDirty();
			}
			return (LRESULT) 1;
		}
		break;
	case WM_NOTIFY:
		if (wParam == IDC_DSF_LIST){
			if(1 == OnClickList(wParam, lParam)) return (LRESULT) 1;
		}
        break;
	}
	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT CHWDeintProp_DSF::OnApplyChanges(void)
{
	TCHAR s[32];
	DWORD merit;
	int ret;
	//bg̓ǂݍ
	ret = SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_GETCURSEL, 0, 0);
	if(CB_ERR == ret){
		GetDlgItemText(m_Dlg, IDC_DSF_MERIT, s, 32);
		s[ARRAYSIZE(s) - 1] = _T('\0'); //Ŝ

		ret = _stscanf_s(s, _T("%x"), &merit);
		if(ret == 1) m_newmerit = merit;
	}
	StringCchPrintf(s, ARRAYSIZE(s), _T("%.8x"), m_newmerit);
	SetDlgItemText(m_Dlg, IDC_DSF_MERIT, s);

	//ȃtB^̓ǂݍ
	ParseFilterList();

	m_pHWDeint->set_dsflist(&m_dsflist);

	//WXgɃZ[u
	SaveDSFlist(m_dsflist);
	if(m_newmerit != m_merit){
		m_merit = m_newmerit;
		SetMerit(m_merit);
	}

	//Auto load ݒ
	if(m_cfg_al.al_clsid == GUID_NULL){
		m_cfg_al.al_filter_name = NULL;
	}else{
		m_cfg_al.al_filter_name = m_al_name;
	}
	m_pHWDeint->set_cfg_al(m_cfg_al);

	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnApplyChanges")));

	return S_OK;
} 

HRESULT CHWDeintProp_DSF::OnDisconnect(void)
{
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnDisconnect")));

    if (m_pHWDeint)
    {
        m_pHWDeint->Release();
        m_pHWDeint = NULL;
    }
    return S_OK;
}

//bglWXgǂ
DWORD CHWDeintProp_DSF::GetMerit(void)
{
	HKEY   hKey;
	LONG   ret;
	DWORD  size;
	DWORD  merit;
	LPBYTE buf;

	RegOpenKeyEx(HKEY_CLASSES_ROOT, HWDI_REG_SUBKEY_FINFO, 0, KEY_READ, &hKey);

	ret = RegQueryValueEx(hKey, _T("FilterData"), NULL, NULL, NULL, &size);
	if(ret != ERROR_SUCCESS){
			RegCloseKey(hKey);
			return 0;
	}
	buf = new BYTE[size];
	if(!buf){
		RegCloseKey(hKey);
		return 0;
	}
	ret = RegQueryValueEx(hKey, _T("FilterData"), NULL, NULL, (LPBYTE)buf, &size);
	if(ret != ERROR_SUCCESS){
		delete[] buf;
		RegCloseKey(hKey);
		return 0;
	}

	merit = reinterpret_cast<REGFILTER2*>(buf)->dwMerit;

	delete[] buf;
	RegCloseKey(hKey);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::GetMerit merit:%x"), merit));

	return merit;
}

//bgWXgɃZ[u
DWORD CHWDeintProp_DSF::SetMerit(DWORD merit)
{
	HKEY   hKey;
	LONG   ret;
	DWORD  size;
	LPBYTE buf;

	RegOpenKeyEx(HKEY_CLASSES_ROOT, HWDI_REG_SUBKEY_FINFO, 0, KEY_READ|KEY_WRITE, &hKey);

	ret = RegQueryValueEx(hKey, _T("FilterData"), NULL, NULL, NULL, &size);
	if(ret != ERROR_SUCCESS){
			RegCloseKey(hKey);
			return 0;
	}
	buf = new(nothrow) BYTE[size];
	if(!buf){
		RegCloseKey(hKey);
		return 0;
	}
	ret = RegQueryValueEx(hKey, _T("FilterData"), NULL, NULL, (LPBYTE)buf, &size);
	if(ret != ERROR_SUCCESS){
		delete[] buf;
		return 0;
	}

	reinterpret_cast<REGFILTER2*>(buf)->dwMerit = merit;
	RegSetValueEx(hKey, _T("FilterData"), 0, REG_BINARY, buf, size);

	delete[] buf;
	RegCloseKey(hKey);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::SetMerit merit:%x"), merit));

	//f[^x[XXV̂ߓK UnregisterFilter() sĂ݂
	IFilterMapper2 *pFM2 = NULL;
	HRESULT hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
		IID_IFilterMapper2, (void **)&pFM2);
	if (SUCCEEDED(hr))
	{
		//̓G[Ԃ
		hr = pFM2->UnregisterFilter(NULL, NULL, GUID_NULL);
		pFM2->Release();
	}

	return merit;
}

//Auto load ̑I
HRESULT CHWDeintProp_DSF::OnClickALSel(void)
{
	int item;
	LVITEM lvi;
	vector<dsfid>::iterator p = m_dsflist_all.begin();

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask = LVIF_PARAM;
	lvi.iSubItem = 0;

	//ڂ̐
	item = SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEMCOUNT, 0, 0);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::OnClickALSel items:%d"), item));

	for(int i=0; i<item; ++i){
		lvi.iItem = i;
		if(ListView_GetItemState(GetDlgItem(m_Dlg,IDC_DSF_LIST), i, LVIS_SELECTED)){
			if(SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEM, 0, (LPARAM)&lvi )){
				if((p + lvi.lParam)->hasCLSID()){
					//IĂāACLSIDꍇ
					const WCHAR *wp = (p + lvi.lParam)->c_str_name();
					m_cfg_al.al_clsid = (p + lvi.lParam)->getCLSID();
					SendDlgItemMessageW(m_Dlg, IDC_AUTOLOAD_NAME, WM_SETTEXT, 0, (LPARAM)wp);
					StringCchCopyW(m_al_name, MAX_FILTER_NAME, (p + lvi.lParam)->c_str_name());
					return 1;
				}
			}
		}
	}

	return 0;
}

//bgR{{bNX
HRESULT CHWDeintProp_DSF::OnClickMerit(WPARAM wParam)
{
	if (HIWORD(wParam) == CBN_SELENDOK) 
	{ 
		int i;
		i = SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_GETCURSEL, 0, 0);
		switch (i)
		{
		case 0: // MERIT_PREFERRED+2
			m_newmerit = 0x800002U;
			break;
		case 1: // MERIT_DO_NOT_USE
			m_newmerit = 0x200000U;
			break;
		}
		SetDirty();
		return (LRESULT) 1;
	} else if (HIWORD(wParam) == CBN_KILLFOCUS) {
		TCHAR s[64];
		DWORD merit;
		int ret;
		//bg̓ǂݍ
		ret = SendDlgItemMessage(m_Dlg, IDC_DSF_MERIT, CB_GETCURSEL, 0, 0);
		if(CB_ERR == ret){
			GetDlgItemText(m_Dlg, IDC_DSF_MERIT, s, 63);
			s[ARRAYSIZE(s) - 1] = _T('\0'); //Ŝ
			ret = _stscanf_s(s, _T("%x"), &merit);
			if(ret != 1){ // lُ
				merit = m_newmerit;
			}
		}else{
			merit = m_newmerit;
		}
		StringCchPrintf(s, ARRAYSIZE(s), _T("%.8x"), merit);
		SetDlgItemText(m_Dlg, IDC_DSF_MERIT, s);
		if( m_newmerit !=  m_merit ){
			SetDirty();
			return (LRESULT) 1;
		}
	} else if (HIWORD(wParam) == CBN_EDITCHANGE) {
		SetDirty();
		return (LRESULT) 1;
	}

	return 0;
}

//Xg
HRESULT CHWDeintProp_DSF::OnClickList(WPARAM wParam, LPARAM lParam)
{
	switch (((NMHDR*)lParam)->code)
	{
	case LVN_COLUMNCLICK: 
		if(((NMLISTVIEW*)lParam)->iSubItem == 0){
			SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_SORTITEMSEX,
				(WPARAM)this, (LPARAM)CmpList);
			m_sort = m_sort>2 ? 0 : m_sort+1;
		} else if (((NMLISTVIEW*)lParam)->iSubItem == 1){
			SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_SORTITEMSEX,
				(WPARAM)this, (LPARAM)CmpList2);
			m_sort2 = m_sort2>2 ? 0 : m_sort2+1;
		}
		break;
	case LVN_KEYDOWN:
		if(((NMLVKEYDOWN*)lParam)->wVKey == VK_SPACE){
			int idx = ListView_GetSelectionMark(GetDlgItem(m_Dlg,IDC_DSF_LIST));
			if(idx == -1) break;

			LVITEM lvi;
			vector<dsfid>::iterator p = m_dsflist_all.begin();

			ZeroMemory(&lvi, sizeof(lvi));
			lvi.iItem = idx;
			lvi.mask = LVIF_PARAM;
			if(SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEM, 0, (LPARAM)&lvi )){
				(p + lvi.lParam)->checked = !(p + lvi.lParam)->checked;
				SetDirty();
				return (LRESULT) 1;
			}
		}
		break;
	case NM_CLICK:
		clicked = true;
		break;
	case LVN_ITEMCHANGED:
		NMLISTVIEW *pN = (NMLISTVIEW*)lParam;
		if(pN->iItem != -1 && pN->uChanged == LVIF_STATE && clicked){
			LVITEM lvi;
			vector<dsfid>::iterator p = m_dsflist_all.begin();

			ZeroMemory(&lvi, sizeof(lvi));
			lvi.iItem = pN->iItem;
			lvi.mask = LVIF_PARAM;
			if(SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEM, 0, (LPARAM)&lvi )){
				if((p + lvi.lParam)->checked != (0 !=
					ListView_GetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), pN->iItem))){
					(p + lvi.lParam)->checked = !(p + lvi.lParam)->checked;
					SetDirty();
					return (LRESULT) 1;
				}
			}
		}
		break;
	}

	return 0;
}

HRESULT CHWDeintProp_DSF::ParseFilterList(void)
{
	int item;
	LVITEM lvi;
	vector<dsfid>::iterator p = m_dsflist_all.begin();

	ZeroMemory(&lvi, sizeof(lvi));
	lvi.mask = LVIF_PARAM;
	lvi.iSubItem = 0;

	m_dsflist.clear();
	//ڂ̐
	item = SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEMCOUNT, 0, 0);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::ParseFilterList items:%d"), item));

	for(int i=0; i<item; ++i){
		lvi.iItem = i;
		if(ListView_GetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), i)){
			if(SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEM, 0, (LPARAM)&lvi )){
				m_dsflist.push_back(*(p + lvi.lParam));
			}
		}
	}
	sort(m_dsflist.begin(), m_dsflist.end());
	p = unique(m_dsflist.begin(), m_dsflist.end());
	m_dsflist.erase(p, m_dsflist.end());

	return NOERROR;
}

HRESULT CHWDeintProp_DSF::ClearFilterList(void)
{
	int item;

	//ڂ̐
	item = SendDlgItemMessage(m_Dlg, IDC_DSF_LIST, LVM_GETITEMCOUNT, 0, 0);
	DbgLog((LOG_TRACE, 3, TEXT("CHWDeintProp_DSF::ClearFilterList items:%d"), item));

	for(int i=0; i<item; ++i){
		ListView_SetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), i, FALSE);
	}

	vector<dsfid>::iterator p = m_dsflist_all.begin();
	while(p != m_dsflist_all.end()){
		p->checked = false;
		++p;
	}

	return NOERROR;
}

HRESULT CHWDeintProp_DSF::ListFilters(void)
{
	int n = 0;
	int idx = -1;

	vector<dsfid>::iterator p = m_dsflist_all.begin();
	while(p != m_dsflist_all.end()){
	
		// AvP[ṼXg {bNXɒǉB
		// name
		LV_ITEMW lvi_name;
		ZeroMemory(&lvi_name, sizeof(lvi_name));

		lvi_name.mask = LVIF_TEXT | LVIF_PARAM;
		lvi_name.iSubItem = 0;
		lvi_name.lParam = n;
		if(p->hasNAME()){
			lvi_name.pszText = const_cast<LPWSTR>(p->c_str_name());
		}else{
			lvi_name.pszText = str_noitem;
		}
		idx = SendDlgItemMessageW(m_Dlg, IDC_DSF_LIST, LVM_INSERTITEMW, 0, (LPARAM)&lvi_name);

		if(idx != -1){
			// CLSID
			LV_ITEMW lvi_cls;
			ZeroMemory(&lvi_cls, sizeof(lvi_cls));

			lvi_cls.mask = LVIF_TEXT;
			lvi_cls.iItem = idx;
			lvi_cls.iSubItem = 1;
			if(p->hasCLSID()){
				lvi_cls.pszText =  const_cast<LPWSTR>(p->c_str_cls());
			}else{
				lvi_cls.pszText = str_noitem;
			}
			if(!SendDlgItemMessageW(m_Dlg, IDC_DSF_LIST, LVM_SETITEMW, 0, (LPARAM)&lvi_cls)){
				idx = -1;
			}

		}
		if(idx != -1){
			BOOL fCheck = p->checked;
			ListView_SetCheckState(GetDlgItem(m_Dlg,IDC_DSF_LIST), idx, fCheck);
		}
		++p;
		++n;
	}

	return NOERROR;
}

HRESULT CHWDeintProp_DSF::EnumClass(CLSID cls, ICreateDevEnum *pSysDevEnum)
{
	ASSERT(pSysDevEnum != NULL);

	// NX񋓎q擾B
	IEnumMoniker *pEnumCat = NULL;
	HRESULT hr;
	hr = pSysDevEnum->CreateClassEnumerator(cls, &pEnumCat, 0);

	if (hr == S_OK) 
	{
		// jJ񋓂B
		IMoniker *pMoniker = NULL;
		ULONG cFetched;

		while(pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK)
		{
			IPropertyBag *pPropBag;
			hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pPropBag);
			if (SUCCEEDED(hr))
			{
				dsfid di;

				// tB^̃th擾
				VARIANT varName;
				VariantInit(&varName);
				hr = pPropBag->Read(L"FriendlyName", &varName, 0);
				if (SUCCEEDED(hr))
				{
					di.setNAME(varName.bstrVal);
				}
				VariantClear(&varName);

				VARIANT varClsid;
				VariantInit(&varClsid);
				hr = pPropBag->Read(L"CLSID", &varClsid, 0);
				if (SUCCEEDED(hr))
				{
					di.setCLSID(varClsid.bstrVal);
				}
				VariantClear(&varClsid);

				pPropBag->Release();

				if(di.hasCLSID() || di.hasNAME()){
					//append dsfid
					vector<dsfid>::iterator p = find(m_dsflist.begin(), m_dsflist.end(),di);
					if(m_dsflist.end() != p){
						di.checked = true;
						p->listed = true;
					}
					m_dsflist_all.push_back(di);
				}
			}
			pMoniker->Release();
		}
		pEnumCat->Release();
	}
	return S_OK;
}

HRESULT CHWDeintProp_DSF::EnumFilters(void)
{
	m_dsflist_all.clear();

	// System Device Enumerator 쐬B
	HRESULT hr;
	ICreateDevEnum *pSysDevEnum = NULL;
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
		IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return hr;
	}

	// DirectShow Filters JeS̃NX񋓎q擾B
	EnumClass(CLSID_LegacyAmFilterCategory, pSysDevEnum);

	// Video Capture Sources JeS̃NX񋓎q擾B
	EnumClass(CLSID_VideoInputDeviceCategory, pSysDevEnum);

	pSysDevEnum->Release();

	//append non-global filter
	vector<dsfid>::iterator p = m_dsflist.begin();
	while(p != m_dsflist.end()){
		if(!p->listed){
			p->checked = true;
			m_dsflist_all.push_back(*p);
		}
		++p;
	}
	sort(m_dsflist_all.begin(), m_dsflist_all.end());
	p = unique(m_dsflist_all.begin(), m_dsflist_all.end());
	m_dsflist_all.erase(p, m_dsflist_all.end());
	
	return hr;
}

// list sort function
int CALLBACK CmpList(LPARAM lP1, LPARAM lP2, LPARAM lPS)
{
	int ret = 0;
	CHWDeintProp_DSF *cdd = (CHWDeintProp_DSF *)lPS;

	if(cdd->m_sort > 1){
		BOOL b0, b1;
		b0 = ListView_GetCheckState(GetDlgItem(cdd->m_Dlg,IDC_DSF_LIST), lP1);
		b1 = ListView_GetCheckState(GetDlgItem(cdd->m_Dlg,IDC_DSF_LIST), lP2);
		if(b0!=b1){
			ret = b0 ? -1 : 1;
		}
	}
	if(ret == 0){
		//cmp by name

		TCHAR buf0[MAX_FILTER_NAME];
		TCHAR buf1[MAX_FILTER_NAME];
		LVITEM lvi0;
		LVITEM lvi1;

		ZeroMemory(&lvi0, sizeof(lvi0));
		ZeroMemory(buf0, sizeof(buf0));
		lvi0.mask = LVIF_TEXT;
		lvi0.iSubItem = 0;
		lvi0.pszText = (LPTSTR)buf0;
		lvi0.cchTextMax = MAX_FILTER_NAME-1;
		ZeroMemory(&lvi1, sizeof(lvi1));
		ZeroMemory(buf1, sizeof(buf1));
		lvi1.mask = LVIF_TEXT;
		lvi1.iSubItem = 0;
		lvi1.pszText = (LPTSTR)buf1;
		lvi1.cchTextMax = MAX_FILTER_NAME-1;

		SendDlgItemMessage(cdd->m_Dlg, IDC_DSF_LIST, LVM_GETITEMTEXT, lP1, (LPARAM)&lvi0 );
		SendDlgItemMessage(cdd->m_Dlg, IDC_DSF_LIST, LVM_GETITEMTEXT, lP2, (LPARAM)&lvi1 );

		ret = _tcsicmp(buf0, buf1);
	}

	return cdd->m_sort&1 ? -ret : ret;
}

// list sort function
int CALLBACK CmpList2(LPARAM lP1, LPARAM lP2, LPARAM lPS)
{
	int ret = 0;
	CHWDeintProp_DSF *cdd = (CHWDeintProp_DSF *)lPS;

	if(cdd->m_sort2 > 1){
		BOOL b0, b1;
		b0 = ListView_GetCheckState(GetDlgItem(cdd->m_Dlg,IDC_DSF_LIST), lP1);
		b1 = ListView_GetCheckState(GetDlgItem(cdd->m_Dlg,IDC_DSF_LIST), lP2);
		if(b0!=b1){
			ret = b0 ? -1 : 1;
		}
	}
	if(ret == 0){
		//cmp by clsid

		TCHAR buf0[CHARS_IN_GUID+1];
		TCHAR buf1[CHARS_IN_GUID+1];
		LVITEM lvi0;
		LVITEM lvi1;

		ZeroMemory(&lvi0, sizeof(lvi0));
		ZeroMemory(buf0, sizeof(buf0));
		lvi0.mask = LVIF_TEXT;
		lvi0.iSubItem = 1;
		lvi0.pszText = (LPTSTR)buf0;
		lvi0.cchTextMax = CHARS_IN_GUID;
		ZeroMemory(&lvi1, sizeof(lvi1));
		ZeroMemory(buf1, sizeof(buf1));
		lvi1.mask = LVIF_TEXT;
		lvi1.iSubItem = 1;
		lvi1.pszText = (LPTSTR)buf1;
		lvi1.cchTextMax = CHARS_IN_GUID;

		SendDlgItemMessage(cdd->m_Dlg, IDC_DSF_LIST, LVM_GETITEMTEXT, lP1, (LPARAM)&lvi0 );
		SendDlgItemMessage(cdd->m_Dlg, IDC_DSF_LIST, LVM_GETITEMTEXT, lP2, (LPARAM)&lvi1 );

		ret = _tcsicmp(buf0, buf1);
	}

	return cdd->m_sort2&1 ? -ret : ret;
}
