//  tray.cpp
//
//	tray
//
//	Copyright (c) 2005 N099
//
#include <streams.h>     // DirectShow (includes windows.h)
#include <dvdmedia.h>
#include <tchar.h>
#include <strsafe.h>

#include "hwdeintdefs.h"
#include "hwdeint.h"

#include "tray.h"
#include "resource.h"

#define UID_TRAYICON 3002
#define MSG_TRAYICON (WM_APP+15)

//window class name
static TCHAR cls_tray[] = TEXT("hwdeint_tray");

//Menu call back
static LRESULT CALLBACK trayWndProc(HWND hwnd, UINT msg, WPARAM wprm, LPARAM lprm)
{
	TrayIcon *ti = reinterpret_cast<TrayIcon*>(GetWindowLongPtr(hwnd, GWL_USERDATA));

	if(msg == MSG_TRAYICON){
		if(ti == NULL) return 0;

		switch (lprm)
		{
		case WM_LBUTTONDBLCLK:
			ti->show_prop();
			return 0;

		case WM_LBUTTONUP:
			ti->m_ihwd->reset_autodetect();
			return 0;

        case WM_RBUTTONUP:
		case WM_CONTEXTMENU:
			POINT p;
			if(ti->m_ihwd == NULL) return 0;

			//create popup menu
			GetCursorPos(&p);
			ti->m_ihwd->get_cfg_ar(&ti->m_ar);
            ti->m_ihwd->get_cfg_am2(&ti->m_am2);
			ti->m_ihwd->get_cfg_vif2(&ti->m_vif2);
			if(!ti->m_vif2.interlace){
				EnableMenuItem(ti->m_hMenu, IDM_IMEDIA2, MF_GRAYED);
				EnableMenuItem(ti->m_hMenu, IDM_WEAVE, MF_GRAYED);
				EnableMenuItem(ti->m_hMenu, IDM_FIELD1FIRST, MF_GRAYED);
			}else{
				EnableMenuItem(ti->m_hMenu, IDM_IMEDIA2, MF_ENABLED);
				EnableMenuItem(ti->m_hMenu, IDM_WEAVE, MF_ENABLED);
				EnableMenuItem(ti->m_hMenu, IDM_FIELD1FIRST, MF_ENABLED);
			}
			if(ti->m_am2.use_imedia2){
				CheckMenuItem(ti->m_hMenu, IDM_IMEDIA2, MF_CHECKED);
				EnableMenuItem(ti->m_hMenu, IDM_WEAVE, MF_ENABLED);
				EnableMenuItem(ti->m_hMenu, IDM_FIELD1FIRST, MF_ENABLED);
			}else{
				CheckMenuItem(ti->m_hMenu, IDM_IMEDIA2, MF_UNCHECKED);
				EnableMenuItem(ti->m_hMenu, IDM_FIELD1FIRST, MF_GRAYED);
				EnableMenuItem(ti->m_hMenu, IDM_WEAVE, MF_GRAYED);
			}
			CheckMenuRadioItem(ti->m_hMenu, IDM_AR_KEEPORIGINAL, IDM_AR_USERDEFINED,
				IDM_AR_KEEPORIGINAL + ti->m_ar.ar_mode, MF_BYCOMMAND);
			CheckMenuItem(ti->m_hMenu, IDM_FIELD1FIRST, ti->m_am2.am2_tff ? MF_CHECKED:MF_UNCHECKED);
			CheckMenuItem(ti->m_hMenu, IDM_WEAVE, ti->m_am2.weave ? MF_CHECKED:MF_UNCHECKED);
			SetForegroundWindow(hwnd);
			TrackPopupMenu(ti->m_hMenu,TPM_RIGHTALIGN|TPM_BOTTOMALIGN, p.x, p.y, 0, hwnd, NULL);
			return 0;
		}
	} else if(msg == WM_COMMAND) {//if(msg==MSG_TRAYICON)
		//handle popup window message
		if(ti == NULL) return 0;
		if(ti->m_ihwd == NULL) return 0;

		switch (LOWORD(wprm))
		{
		case IDM_SHOWPROP:
			ti->show_prop();
			return 0;
		case IDM_IMEDIA2:
			ti->m_am2.use_imedia2 = !ti->m_am2.use_imedia2;
			ti->m_ihwd->set_cfg_am2(ti->m_am2);
			break;
		case IDM_FIELD1FIRST:
			ti->m_am2.am2_tff = !ti->m_am2.am2_tff;
			ti->m_ihwd->set_cfg_am2(ti->m_am2);
			break;
		case IDM_WEAVE:
			ti->m_am2.weave = !ti->m_am2.weave;
			ti->m_ihwd->set_cfg_am2(ti->m_am2);
			break;
		case IDM_AR_KEEPORIGINAL:
			ti->m_ar.ar_mode = AR_ORIG;
			ti->m_ihwd->set_cfg_ar(ti->m_ar);
			break;
		case IDM_AR_43:
			ti->m_ar.ar_mode = AR_43;
			ti->m_ihwd->set_cfg_ar(ti->m_ar);
			break;
		case IDM_AR_169:
			ti->m_ar.ar_mode = AR_169;
			ti->m_ihwd->set_cfg_ar(ti->m_ar);
			break;
		case IDM_AR_USERDEFINED:
			ti->m_ar.ar_mode = AR_UD;
			ti->m_ihwd->set_cfg_ar(ti->m_ar);
			break;
		}
		ti->m_ihwd->get_cfg_ar(&ti->m_ar);
        ti->m_ihwd->get_cfg_am2(&ti->m_am2);
		return 0;
	}

	return DefWindowProc(hwnd,msg,wprm,lprm);
}


//constructor
TrayIcon::TrayIcon(IHWDeint *ihwd)
 : m_visible(false), m_prop_shown(0)
{
	//load caption
	TCHAR buff[64];
	LoadString(g_hInst, IDS_HWDeintTray, buff, sizeof(buff));
	buff[ARRAYSIZE(buff)-1] = TEXT('\0');

	//register class
	WNDCLASS wndclass;
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = trayWndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = m_hi = g_hInst;
	wndclass.hIcon         = NULL;
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = GetSysColorBrush(COLOR_BTNFACE);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = cls_tray;

	m_hAtom = RegisterClass(&wndclass);

	//create window
	m_hWnd = CreateWindow(cls_tray, buff,
		WS_OVERLAPPED | WS_BORDER | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT, CW_USEDEFAULT, 100, 100, NULL, NULL, m_hi, NULL);                     

	//NOTIFYICONDATA
	ZeroMemory(&m_nid, sizeof(m_nid));
	m_nid.cbSize           = sizeof(m_nid);
	m_nid.hWnd             = m_hWnd;
	m_nid.uID              = UID_TRAYICON;
	m_nid.uFlags           = NIF_ICON|NIF_TIP|NIF_MESSAGE;
	m_nid.uCallbackMessage = MSG_TRAYICON;
	m_nid.hIcon            = static_cast<HICON>
		(LoadImage(m_hi, MAKEINTRESOURCE(IDI_HWICON), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR));
	StringCbCopy(m_nid.szTip, sizeof(m_nid.szTip), buff);

	//Menu
	m_hMenuTop = LoadMenu(m_hi, MAKEINTRESOURCE(IDR_HWDMENU));
	m_hMenu = GetSubMenu(m_hMenuTop, 0);


	//hwdeint
	m_ihwd = ihwd;
	if(NULL != m_ihwd){
		SetWindowLongPtr(m_hWnd, GWL_USERDATA, LONG_PTR(this));

		m_ihwd->get_cfg_ar(&m_ar);
		m_ihwd->get_cfg_am2(&m_am2);
		m_ihwd->get_cfg_vif2(&m_vif2);

		m_visible = (m_ihwd->is_tray_visible() != 0);
		if(m_visible){
			Shell_NotifyIcon(NIM_ADD, &m_nid);
		}
	}

	DbgLog((LOG_TRACE, 2, TEXT("TrayIcon::TrayIcon")));
}

//destructor
TrayIcon::~TrayIcon()
{
	Shell_NotifyIcon(NIM_DELETE, &m_nid);
	DestroyWindow(m_hWnd);
	UnregisterClass(cls_tray, m_hi);
	DestroyMenu(m_hMenuTop);
	DestroyIcon(m_nid.hIcon);

	DbgLog((LOG_TRACE, 2, TEXT("TrayIcon::~TrayIcon")));
}

void TrayIcon::show(void)
{
	if(!m_visible){
		Shell_NotifyIcon(NIM_ADD, &m_nid);
		m_visible = true;
	}
}

void TrayIcon::hide(void)
{
	if(m_visible){
		Shell_NotifyIcon(NIM_DELETE, &m_nid);
		m_visible=false;
	}
}

//display property pages
void TrayIcon::show_prop(void){
	IBaseFilter *pFilter = NULL;
	ISpecifyPropertyPages *pProp = NULL;
	HRESULT hr = E_FAIL;

	if(InterlockedCompareExchange(&m_prop_shown, 1, 0) == 1){
		//already opened
		return;
	}

	//get interface
	if(NULL != m_ihwd){
		hr = m_ihwd->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
		if(SUCCEEDED(hr)){
			hr = m_ihwd->QueryInterface(IID_IBaseFilter, (void **)&pFilter);
		}
	}

	//disp prop
	if (SUCCEEDED(hr)) 
	{
		// tB^̖O IUnknown |C^擾
		FILTER_INFO FilterInfo;
		hr = pFilter->QueryFilterInfo(&FilterInfo); 
		IUnknown *pUnk;
		pFilter->QueryInterface(IID_IUnknown, (void **)&pUnk);

		if(FilterInfo.pGraph) FilterInfo.pGraph->Release();

		// y[W\B
		CAUUID caGUID;
		pProp->GetPages(&caGUID);

		OleCreatePropertyFrame(m_hWnd, 0, 0, FilterInfo.achName,
			1, &pUnk, caGUID.cElems, caGUID.pElems, 0, 0, NULL);

		// N[ Abv
		pUnk->Release();
		CoTaskMemFree(caGUID.pElems);
	}

	//Release
	if(pFilter) pFilter->Release();
	if(pProp) pProp->Release();

	InterlockedExchange(&m_prop_shown, 0);
}

